        SUBROUTINE  NNT
     *     (N, R,C, IL,JL,L, D, IU,JU,U, Z, B, TMP)                       ND 679
C                                                                         ND 680
C       INPUT VARIABLES:   N, R,C, IL,JL,L, D, IU,JU,U, B                 ND 681
C       OUTPUT VARIABLES:  Z                                              ND 682
C                                                                         ND 683
C       PARAMETERS USED INTERNALLY:                                       ND 684
C FIA   \ TMP   - HOLDS NEW RIGHT-HAND SIDE B' FOR SOLUTION OF THE        ND 685
C       \           EQUATION LX = B'.                                     ND 686
C       \           SIZE = N.                                             ND 687
C                                                                         ND 688
        INTEGER  R(1), C(1),  IL(1), JL(1),  IU(1), JU(1)                 ND 689
C       REAL  L(1), D(1), U(1),  Z(1), B(1),  TMP(1), TMPK                ND 690
        DOUBLE PRECISION  L(1), D(1), U(1),  Z(1), B(1),  TMP(1), TMPK    ND 691
C                                                                         ND 692
C  ******  SOLVE  UT Y = B  BY FORWARD SUBSTITUTION  *******************  ND 693
        DO 1 K=1,N                                                        ND 694
   1      TMP(K) = B(C(K))                                                ND 695
        DO 3 K=1,N                                                        ND 696
          TMPK = - TMP(K)                                                 ND 697
          JMIN = IU(K)                                                    ND 698
          JMAX = IU(K+1) - 1                                              ND 699
          IF (JMIN.GT.JMAX)  GO TO 3                                      ND 700
          DO 2 J=JMIN,JMAX                                                ND 701
   2        TMP(JU(J)) = TMP(JU(J)) + U(J) * TMPK                         ND 702
   3      CONTINUE                                                        ND 703
C                                                                         ND 704
C  ******  SOLVE  D LT X = Y  BY BACK SUBSTITUTION  ********************  ND 705
        K = N                                                             ND 706
        DO 6 I=1,N                                                        ND 707
          TMPK = - TMP(K) * D(K)                                          ND 708
          JMIN = IL(K)                                                    ND 709
          JMAX = IL(K+1) - 1                                              ND 710
          IF (JMIN.GT.JMAX)  GO TO 5                                      ND 711
          DO 4 J=JMIN,JMAX                                                ND 712
   4        TMP(JL(J)) = TMP(JL(J)) + L(J) * TMPK                         ND 713
   5      Z(R(K)) = - TMPK                                                ND 714
   6      K = K-1                                                         ND 715
        RETURN                                                            ND 716
        END                                                               ND 717

        SUBROUTINE  TDRV
     *     (N, R,IC, IA,JA,A, B, Z, NSP,ISP,RSP,ESP, FLAG)                TD  12
C                                                                         TD  13
C    PARAMETERS                                                           TD  14
C    CLASS ABBREVIATIONS ARE --                                           TD  15
C       N - INTEGER VARIABLE                                              TD  16
C       F - REAL VARIABLE                                                 TD  17
C       V - SUPPLIES A VALUE TO THE DRIVER                                TD  18
C       R - RETURNS A RESULT FROM THE DRIVER                              TD  19
C       I - USED INTERNALLY BY THE DRIVER                                 TD  20
C       A - ARRAY                                                         TD  21
C                                                                         TD  22
C CLASS \ PARAMETER                                                       TD  23
C ------+----------                                                       TD  24
C       \                                                                 TD  25
C         THE NONZERO ENTRIES OF THE COEFFICIENT MATRIX M ARE STORED      TD  26
C    ROW-BY-ROW IN THE ARRAY A.  TO IDENTIFY THE INDIVIDUAL NONZERO       TD  27
C    ENTRIES IN EACH ROW, WE NEED TO KNOW IN WHICH COLUMN EACH ENTRY      TD  28
C    LIES.  THE COLUMN INDICES WHICH CORRESPOND TO THE NONZERO ENTRIES    TD  29
C    OF M ARE STORED IN THE ARRAY JA;  I.E., IF  A(K) = M(I,J),  THEN     TD  30
C    JA(K) = J.  IN ADDITION, WE NEED TO KNOW WHERE EACH ROW STARTS AND   TD  31
C    HOW LONG IT IS.  THE INDEX POSITIONS IN JA AND A WHERE THE ROWS OF   TD  32
C    M BEGIN ARE STORED IN THE ARRAY IA;  I.E., IF M(I,J) IS THE FIRST    TD  33
C    NONZERO ENTRY (STORED) IN THE I-TH ROW AND A(K) = M(I,J),  THEN      TD  34
C    IA(I) = K.  MOREOVER, THE INDEX IN JA AND A OF THE FIRST LOCATION    TD  35
C    FOLLOWING THE LAST ELEMENT IN THE LAST ROW IS STORED IN IA(N+1).     TD  36
C    THUS, THE NUMBER OF ENTRIES IN THE I-TH ROW IS GIVEN BY              TD  37
C    IA(I+1) - IA(I),  THE NONZERO ENTRIES OF THE I-TH ROW ARE STORED     TD  38
C    CONSECUTIVELY IN                                                     TD  39
C            A(IA(I)),  A(IA(I)+1),  ..., A(IA(I+1)-1),                   TD  40
C    AND THE CORRESPONDING COLUMN INDICES ARE STORED CONSECUTIVELY IN     TD  41
C            JA(IA(I)), JA(IA(I)+1), ..., JA(IA(I+1)-1).                  TD  42
C    FOR EXAMPLE, THE 5 BY 5 MATRIX                                       TD  43
C                ( 1. 0. 2. 0. 0.)                                        TD  44
C                ( 0. 3. 0. 0. 0.)                                        TD  45
C            M = ( 0. 4. 5. 6. 0.)                                        TD  46
C                ( 0. 0. 0. 7. 0.)                                        TD  47
C                ( 0. 0. 0. 8. 9.)                                        TD  48
C    WOULD BE STORED AS                                                   TD  49
C               \ 1  2  3  4  5  6  7  8  9                               TD  50
C            ---+--------------------------                               TD  51
C            IA \ 1  3  4  7  8 10                                        TD  52
C            JA \ 1  3  2  2  3  4  4  4  5                               TD  53
C             A \ 1. 2. 3. 4. 5. 6. 7. 8. 9.         .                    TD  54
C                                                                         TD  55
C NV    \ N     - NUMBER OF VARIABLES/EQUATIONS.                          TD  56
C FVA   \ A     - NONZERO ENTRIES OF THE COEFFICIENT MATRIX M, STORED     TD  57
C       \           BY ROWS.                                              TD  58
C       \           SIZE = NUMBER OF NONZERO ENTRIES IN M.                TD  59
C NVA   \ IA    - POINTERS TO DELIMIT THE ROWS IN A.                      TD  60
C       \           SIZE = N+1.                                           TD  61
C NVA   \ JA    - COLUMN NUMBERS CORRESPONDING TO THE ELEMENTS OF A.      TD  62
C       \           SIZE = SIZE OF A.                                     TD  63
C FVA   \ B     - RIGHT-HAND SIDE B;  B AND Z CAN THE SAME ARRAY.         TD  64
C       \           SIZE = N.                                             TD  65
C FRA   \ Z     - SOLUTION X;  B AND Z CAN BE THE SAME ARRAY.             TD  66
C       \           SIZE = N.                                             TD  67
C                                                                         TD  68
C         THE ROWS AND COLUMNS OF THE ORIGINAL MATRIX M CAN BE            TD  69
C    REORDERED (E.G., TO REDUCE FILLIN OR ENSURE NUMERICAL STABILITY)     TD  70
C    BEFORE CALLING THE DRIVER.  IF NO REORDERING IS DONE, THEN SET       TD  71
C    R(I) = C(I) = IC(I) = I  FOR I=1,...,N.  THE SOLUTION Z IS RETURNED  TD  72
C    IN THE ORIGINAL ORDER.                                               TD  73
C                                                                         TD  74
C NVA   \ R     - ORDERING OF THE ROWS OF M.                              TD  75
C       \           SIZE = N.                                             TD  76
C NVA   \ IC    - INVERSE OF THE ORDERING OF THE COLUMNS OF M;  I.E.,     TD  77
C       \           IC(C(I)) = I  FOR I=1,...,N,  WHERE C IS THE          TD  78
C       \           ORDERING OF THE COLUMNS OF M.                         TD  79
C       \           SIZE = N.                                             TD  80
C                                                                         TD  81
C         VARIOUS ERRORS ARE DETECTED BY THE DRIVER AND THE INDIVIDUAL    TD  82
C    SUBROUTINES.                                                         TD  83
C                                                                         TD  84
C NR    \ FLAG  - ERROR FLAG;  VALUES AND THEIR MEANINGS ARE --           TD  85
C       \             0     NO ERRORS DETECTED                            TD  86
C       \             N+K   NULL ROW IN  A  --  ROW = K                   TD  87
C       \            2N+K   DUPLICATE ENTRY IN A  --  ROW = K             TD  88
C       \            5N+K   NULL PIVOT  --  ROW = K                       TD  89
C       \            8N+K   ZERO PIVOT  --  ROW = K                       TD  90
C       \           10N+1   INSUFFICIENT STORAGE IN TDRV                  TD  91
C       \           12N+K   INSUFFICIENT STORAGE IN TRK                   TD  92
C                                                                         TD  93
C         WORKING STORAGE IS NEEDED FOR THE FACTORED FORM OF THE MATRIX   TD  94
C    M PLUS VARIOUS TEMPORARY VECTORS.  THE ARRAYS ISP AND RSP SHOULD BE  TD  95
C    EQUIVALENCED;  INTEGER STORAGE IS ALLOCATED FROM THE BEGINNING OF    TD  96
C    ISP AND REAL STORAGE FROM THE END OF RSP.                            TD  97
C                                                                         TD  98
C NV    \ NSP   - DECLARED DIMENSION OF RSP;  NSP GENERALLY MUST BE       TD  99
C       \           LARGER THAN 6N+2 + 2*K (WHERE K = (NUMBER OF NONZERO  TD 100
C       \           ENTRIES IN THE UPPER TRIANGLE OF M)).                 TD 101
C NVIRA \ ISP   - INTEGER WORKING STORAGE DIVIDED UP INTO VARIOUS ARRAYS  TD 102
C       \           NEEDED BY THE SUBROUTINES;  ISP AND RSP SHOULD BE     TD 103
C       \           EQUIVALENCED.                                         TD 104
C       \           SIZE = LRATIO*NSP                                     TD 105
C FVIRA \ RSP   - REAL WORKING STORAGE DIVIDED UP INTO VARIOUS ARRAYS     TD 106
C       \           NEEDED BY THE SUBROUTINES;  ISP AND RSP SHOULD BE     TD 107
C       \           EQUIVALENCED.                                         TD 108
C       \           SIZE = NSP.                                           TD 109
C NR    \ ESP   - IF NSP IS SUFFICIENTLY LARGE TO ALLOCATE SPACE, THEN    TD 110
C       \           ESP IS SET TO THE AMOUNT OF EXCESS STORAGE PROVIDED.  TD 111
C                                                                         TD 112
C                                                                         TD 113
C  CONVERSION TO DOUBLE PRECISION                                         TD 114
C                                                                         TD 115
C    TO CONVERT THESE ROUTINES FOR DOUBLE PRECISION ARRAYS, SIMPLY USE    TD 116
C    THE DOUBLE PRECISION DECLARATIONS IN PLACE OF THE REAL DECLARATIONS  TD 117
C    IN EACH SUBPROGRAM;  IN ADDITION, THE DATA VALUE OF THE INTEGER      TD 118
C    VARIABLE LRATIO MUST BE SET AS INDICATED IN SUBROUTINE TDRV          TD 119
C                                                                         TD 120
        INTEGER  R(1), IC(1),  IA(1), JA(1),  ISP(1), ESP,  FLAG,         TD 121
     *     U, ROW, TMP, Q                                                 TD 122
C       REAL  A(1),  B(1),  Z(1),  RSP(1)                                 TD 123
        DOUBLE PRECISION  A(1),  B(1),  Z(1),  RSP(1)                     TD 124
C                                                                         TD 125
C  SET LRATIO EQUAL TO THE RATIO BETWEEN THE LENGTH OF FLOATING POINT     TD 126
C  AND INTEGER ARRAY DATA;  E. G., LRATIO = 1 FOR (REAL, INTEGER),        TD 127
C  LRATIO = 2 FOR (DOUBLE PRECISION, INTEGER)                             TD 128
C                                                                         TD 129
        DATA LRATIO/2/                                                    TD 130
C                                                                         TD 131
C  ******  INITIALIZE AND DIVIDE UP TEMPORARY STORAGE  *****************  TD 132
        IJU = 1                                                           TD 133
        IU  = IJU +  N                                                    TD 134
        Q   = IU  + N+1                                                   TD 135
        IM  = Q   + N+1                                                   TD 136
        U   = (IM + N - 2 + LRATIO) / LRATIO   +   1                      TD 137
        JU  = LRATIO * (U - 1) + 1                                        TD 138
        ROW = NSP + 1 -  N                                                TD 139
        TMP = ROW -  N                                                    TD 140
        MAX = TMP - U                                                     TD 141
        ESP = MAX                                                         TD 142
C                                                                         TD 143
C  ******  CALL ZERO-TRACKING SUBROUTINE  ******************************  TD 144
        IF (MAX.LT.0)  GO TO 110                                          TD 145
        CALL  TRK                                                         TD 146
     *     (N,  R, IC,  IA, JA, A,  Z,  B,                                TD 147
     *      ISP(IJU), ISP(JU), ISP(IU), RSP(U), MAX,                      TD 148
     *      ISP(Q),  ISP(IM),  RSP(ROW),  RSP(TMP), FLAG, ESP, LRATIO)    TD 149
        IF (FLAG.NE.0)  GO TO 100                                         TD 150
        RETURN                                                            TD 151
C                                                                         TD 152
C ** ERROR:  ERROR DETECTED IN TRK                                        TD 153
 100    RETURN                                                            TD 154
C ** ERROR:  INSUFFICIENT STORAGE                                         TD 155
 110    FLAG = 10*N + 1                                                   TD 156
        RETURN                                                            TD 157
        END                                                               TD 158

        SUBROUTINE  ODRV
     *     (N, IA,JA,A, P,IP, NSP,ISP, PATH, FLAG)                        OD   6
C                                                                         OD   7
C  DESCRIPTION                                                            OD   8
C                                                                         OD   9
C    ODRV FINDS A MINIMUM DEGREE ORDERING OF THE ROWS AND COLUMNS OF A    OD  10
C    SYMMETRIC MATRIX M STORED IN (IA,JA,A) FORMAT (SEE BELOW).  FOR THE  OD  11
C    REORDERED MATRIX, THE WORK AND STORAGE REQUIRED TO PERFORM GAUSSIAN  OD  12
C    ELIMINATION IS (USUALLY) SIGNIFICANTLY LESS.                         OD  13
C                                                                         OD  14
C    IF ONLY THE NONZERO ENTRIES IN THE UPPER TRIANGLE OF M ARE BEING     OD  15
C    STORED, THEN ODRV SYMMETRICALLY REORDERS (IA,JA,A), (OPTIONALLY)     OD  16
C    WITH THE DIAGONAL ENTRIES PLACED FIRST IN EACH ROW.  THIS IS TO      OD  17
C    ENSURE THAT IF M(I,J) WILL BE IN THE UPPER TRIANGLE OF M WITH        OD  18
C    RESPECT TO THE NEW ORDERING, THEN M(I,J) IS STORED IN ROW I (AND     OD  19
C    THUS M(J,I) IS NOT STORED);  WHEREAS IF M(I,J) WILL BE IN THE        OD  20
C    STRICT LOWER TRIANGLE OF M, THEN M(J,I) IS STORED IN ROW J (AND      OD  21
C    THUS M(I,J) IS NOT STORED).                                          OD  22
C                                                                         OD  23
C                                                                         OD  24
C  STORAGE OF SPARSE MATRICES                                             OD  25
C                                                                         OD  26
C    THE NONZERO ENTRIES OF THE MATRIX M ARE STORED ROW-BY-ROW IN THE     OD  27
C    ARRAY A.  TO IDENTIFY THE INDIVIDUAL NONZERO ENTRIES IN EACH ROW,    OD  28
C    WE NEED TO KNOW IN WHICH COLUMN EACH ENTRY LIES.  THESE COLUMN       OD  29
C    INDICES ARE STORED IN THE ARRAY JA;  I.E., IF  A(K) = M(I,J),  THEN  OD  30
C    JA(K) = J.  TO IDENTIFY THE INDIVIDUAL ROWS, WE NEED TO KNOW WHERE   OD  31
C    EACH ROW STARTS.  THESE ROW POINTERS ARE STORED IN THE ARRAY IA;     OD  32
C    I.E., IF M(I,J) IS THE FIRST NONZERO ENTRY (STORED) IN THE I-TH ROW  OD  33
C    AND  A(K) = M(I,J),  THEN  IA(I) = K.  MOREOVER, IA(N+1) POINTS TO   OD  34
C    THE FIRST LOCATION FOLLOWING THE LAST ELEMENT IN THE LAST ROW.       OD  35
C    THUS, THE NUMBER OF ENTRIES IN THE I-TH ROW IS  IA(I+1) - IA(I),     OD  36
C    THE NONZERO ENTRIES IN THE I-TH ROW ARE STORED CONSECUTIVELY IN      OD  37
C                                                                         OD  38
C            A(IA(I)),  A(IA(I)+1),  ..., A(IA(I+1)-1),                   OD  39
C                                                                         OD  40
C    AND THE CORRESPONDING COLUMN INDICES ARE STORED CONSECUTIVELY IN     OD  41
C                                                                         OD  42
C            JA(IA(I)), JA(IA(I)+1), ..., JA(IA(I+1)-1).                  OD  43
C                                                                         OD  44
C    SINCE THE COEFFICIENT MATRIX IS SYMMETRIC, ONLY THE NONZERO ENTRIES  OD  45
C    IN THE UPPER TRIANGLE NEED BE STORED.  FOR EXAMPLE, THE MATRIX       OD  46
C                                                                         OD  47
C             ( 1  0  2  3  0 )                                           OD  48
C             ( 0  4  0  0  0 )                                           OD  49
C         M = ( 2  0  5  6  0 )                                           OD  50
C             ( 3  0  6  7  8 )                                           OD  51
C             ( 0  0  0  8  9 )                                           OD  52
C                                                                         OD  53
C    COULD BE STORED AS                                                   OD  54
C                                                                         OD  55
C            \ 1  2  3  4  5  6  7  8  9 10 11 12 13                      OD  56
C         ---+--------------------------------------                      OD  57
C         IA \ 1  4  5  8 12 14                                           OD  58
C         JA \ 1  3  4  2  1  3  4  1  3  4  5  4  5                      OD  59
C          A \ 1  2  3  4  2  5  6  3  6  7  8  8  9                      OD  60
C                                                                         OD  61
C    OR (SYMMETRICALLY) AS                                                OD  62
C                                                                         OD  63
C            \ 1  2  3  4  5  6  7  8  9                                  OD  64
C         ---+--------------------------                                  OD  65
C         IA \ 1  4  5  7  9 10                                           OD  66
C         JA \ 1  3  4  2  3  4  4  5  5                                  OD  67
C          A \ 1  2  3  4  5  6  7  8  9          .                       OD  68
C                                                                         OD  69
C                                                                         OD  70
C  PARAMETERS                                                             OD  71
C                                                                         OD  72
C    N    - ORDER OF THE MATRIX                                           OD  73
C                                                                         OD  74
C    IA   - INTEGER ONE-DIMENSIONAL ARRAY CONTAINING POINTERS TO DELIMIT  OD  75
C           ROWS IN JA AND A;  DIMENSION = N+1                            OD  76
C                                                                         OD  77
C    JA   - INTEGER ONE-DIMENSIONAL ARRAY CONTAINING THE COLUMN INDICES   OD  78
C           CORRESPONDING TO THE ELEMENTS OF A;  DIMENSION = NUMBER OF    OD  79
C           NONZERO ENTRIES IN (THE UPPER TRIANGLE OF) M                  OD  80
C                                                                         OD  81
C    A    - REAL ONE-DIMENSIONAL ARRAY CONTAINING THE NONZERO ENTRIES IN  OD  82
C           (THE UPPER TRIANGLE OF) M, STORED BY ROWS;  DIMENSION =       OD  83
C           NUMBER OF NONZERO ENTRIES IN (THE UPPER TRIANGLE OF) M        OD  84
C                                                                         OD  85
C    P    - INTEGER ONE-DIMENSIONAL ARRAY USED TO RETURN THE PERMUTATION  OD  86
C           OF THE ROWS AND COLUMNS OF M CORRESPONDING TO THE MINIMUM     OD  87
C           DEGREE ORDERING;  DIMENSION = N                               OD  88
C                                                                         OD  89
C    IP   - INTEGER ONE-DIMENSIONAL ARRAY USED TO RETURN THE INVERSE OF   OD  90
C           THE PERMUTATION RETURNED IN P;  DIMENSION = N                 OD  91
C                                                                         OD  92
C    NSP  - DECLARED DIMENSION OF THE ONE-DIMENSIONAL ARRAY ISP;  NSP     OD  93
C           MUST BE AT LEAST  3N+4K,  WHERE K IS THE NUMBER OF NONZEROES  OD  94
C           IN THE STRICT UPPER TRIANGLE OF M                             OD  95
C                                                                         OD  96
C    ISP  - INTEGER ONE-DIMENSIONAL ARRAY USED FOR WORKING STORAGE;       OD  97
C           DIMENSION = NSP                                               OD  98
C                                                                         OD  99
C    PATH - INTEGER PATH SPECIFICATION;  VALUES AND THEIR MEANINGS ARE -  OD 100
C             1  FIND MINIMUM DEGREE ORDERING ONLY                        OD 101
C             2  FIND MINIMUM DEGREE ORDERING AND REORDER SYMMETRICALLY   OD 102
C                  STORED MATRIX (USED WHEN ONLY THE NONZERO ENTRIES IN   OD 103
C                  THE UPPER TRIANGLE OF M ARE BEING STORED)              OD 104
C             3  REORDER SYMMETRICALLY STORED MATRIX AS SPECIFIED BY      OD 105
C                  INPUT PERMUTATION (USED WHEN AN ORDERING HAS ALREADY   OD 106
C                  BEEN DETERMINED AND ONLY THE NONZERO ENTRIES IN THE    OD 107
C                  UPPER TRIANGLE OF M ARE BEING STORED)                  OD 108
C             4  SAME AS 2 BUT PUT DIAGONAL ENTRIES AT START OF EACH ROW  OD 109
C             5  SAME AS 3 BUT PUT DIAGONAL ENTRIES AT START OF EACH ROW  OD 110
C                                                                         OD 111
C    FLAG - INTEGER ERROR FLAG;  VALUES AND THEIR MEANINGS ARE -          OD 112
C               0    NO ERRORS DETECTED                                   OD 113
C              9N+K  INSUFFICIENT STORAGE IN MD                           OD 114
C             10N+1  INSUFFICIENT STORAGE IN ODRV                         OD 115
C             11N+1  ILLEGAL PATH SPECIFICATION                           OD 116
C                                                                         OD 117
C                                                                         OD 118
C  CONVERSION FROM REAL TO DOUBLE PRECISION                               OD 119
C                                                                         OD 120
C    CHANGE THE REAL DECLARATIONS IN ODRV AND SRO TO DOUBLE PRECISION     OD 121
C    DECLARATIONS.                                                        OD 122
C                                                                         OD 123
C-----------------------------------------------------------------------  OD 124
C                                                                         OD 125
        INTEGER  IA(1), JA(1),  P(1), IP(1),  ISP(1),  PATH,  FLAG,       OD 126
     *     V, L, HEAD,  TMP, Q                                            OD 127
        REAL  A(1)                                                        OD 128
C...    DOUBLE PRECISION  A(1)                                            OD 129
        LOGICAL  DFLAG                                                    OD 130
C                                                                         OD 131
C----INITIALIZE ERROR FLAG AND VALIDATE PATH SPECIFICATION                OD 132
        FLAG = 0                                                          OD 133
        IF (PATH.LT.1 .OR. 5.LT.PATH)  GO TO 111                          OD 134
C                                                                         OD 135
C----ALLOCATE STORAGE AND FIND MINIMUM DEGREE ORDERING                    OD 136
        IF ((PATH-1) * (PATH-2) * (PATH-4) .NE. 0)  GO TO 1               OD 137
          MAX = (NSP-N)/2                                                 OD 138
          V    = 1                                                        OD 139
          L    = V     +  MAX                                             OD 140
          HEAD = L     +  MAX                                             OD 141
          NEXT = HEAD  +  N                                               OD 142
          IF (MAX.LT.N)  GO TO 110                                        OD 143
C                                                                         OD 144
          CALL  MD                                                        OD 145
     *       (N, IA,JA, MAX,ISP(V),ISP(L), ISP(HEAD),P,IP, ISP(V), FLAG)  OD 146
          IF (FLAG.NE.0)  GO TO 100                                       OD 147
C                                                                         OD 148
C----ALLOCATE STORAGE AND SYMMETRICALLY REORDER MATRIX                    OD 149
   1    IF ((PATH-2) * (PATH-3) * (PATH-4) * (PATH-5) .NE. 0)  GO TO 2    OD 150
          TMP = (NSP+1) -      N                                          OD 151
          Q   = TMP     - (IA(N+1)-1)                                     OD 152
          IF (Q.LT.1)  GO TO 110                                          OD 153
C                                                                         OD 154
          DFLAG = PATH.EQ.4 .OR. PATH.EQ.5                                OD 155
          CALL SRO                                                        OD 156
     *       (N,  IP,  IA, JA, A,  ISP(TMP),  ISP(Q),  DFLAG)             OD 157
C                                                                         OD 158
   2    RETURN                                                            OD 159
C                                                                         OD 160
C ** ERROR -- ERROR DETECTED IN MD                                        OD 161
 100    RETURN                                                            OD 162
C ** ERROR -- INSUFFICIENT STORAGE                                        OD 163
 110    FLAG = 10*N + 1                                                   OD 164
        RETURN                                                            OD 165
C ** ERROR -- ILLEGAL PATH SPECIFIED                                      OD 166
 111    FLAG = 11*N + 1                                                   OD 167
        RETURN                                                            OD 168
        END                                                               OD 169

        SUBROUTINE  MDP
     *     (K,EK,TAIL, V,L, HEAD,LAST,NEXT, MARK)                         OD 427
        INTEGER  EK, TAIL,  V(1), L(1),  HEAD(1), LAST(1), NEXT(1),       OD 428
     *     MARK(1),  TAG, FREE, LI,VI,LVI,EVI, S,LS,ES, ILP,ILPMAX        OD 429
C                                                                         OD 430
C----INITIALIZE TAG                                                       OD 431
        TAG = MARK(EK)                                                    OD 432
C                                                                         OD 433
C----FOR EACH VERTEX VI IN EK                                             OD 434
        LI = EK                                                           OD 435
        ILPMAX = LAST(EK)                                                 OD 436
        IF (ILPMAX.LE.0)  GO TO 12                                        OD 437
        DO 11 ILP=1,ILPMAX                                                OD 438
          I = LI                                                          OD 439
          LI = L(I)                                                       OD 440
          VI = V(LI)                                                      OD 441
C                                                                         OD 442
C------REMOVE VI FROM DEGREE LIST                                         OD 443
          IF (LAST(VI).EQ.0)  GO TO 3                                     OD 444
            IF (LAST(VI).GT.0)  GO TO 1                                   OD 445
              HEAD(-LAST(VI)) = NEXT(VI)                                  OD 446
              GO TO 2                                                     OD 447
   1          NEXT(LAST(VI)) = NEXT(VI)                                   OD 448
   2        IF (NEXT(VI).GT.0)  LAST(NEXT(VI)) = LAST(VI)                 OD 449
C                                                                         OD 450
C------REMOVE INACTIVE ITEMS FROM ELEMENT LIST OF VI                      OD 451
   3      LS = VI                                                         OD 452
   4      S = LS                                                          OD 453
          LS = L(S)                                                       OD 454
          IF (LS.EQ.0)  GO TO 6                                           OD 455
            ES = V(LS)                                                    OD 456
            IF (MARK(ES).LT.TAG)  GO TO 5                                 OD 457
              FREE = LS                                                   OD 458
              L(S) = L(LS)                                                OD 459
              LS = S                                                      OD 460
   5        GO TO 4                                                       OD 461
C                                                                         OD 462
C------IF VI IS INTERIOR VERTEX, THEN REMOVE FROM LIST AND ELIMINATE      OD 463
   6      LVI = L(VI)                                                     OD 464
          IF (LVI.NE.0)  GO TO 7                                          OD 465
            L(I) = L(LI)                                                  OD 466
            LI = I                                                        OD 467
C                                                                         OD 468
            K = K+1                                                       OD 469
            NEXT(VI) = -K                                                 OD 470
            LAST(EK) = LAST(EK) - 1                                       OD 471
            GO TO 11                                                      OD 472
C                                                                         OD 473
C------ELSE ...                                                           OD 474
C--------CLASSIFY VERTEX VI                                               OD 475
   7        IF (L(LVI).NE.0)  GO TO 9                                     OD 476
              EVI = V(LVI)                                                OD 477
              IF (NEXT(EVI).GE.0)  GO TO 9                                OD 478
                IF (MARK(EVI).LT.0)  GO TO 8                              OD 479
C                                                                         OD 480
C----------IF VI IS PROTOTYPE VERTEX, THEN MARK AS SUCH, INITIALIZE       OD 481
C----------OVERLAP COUNT FOR CORRESPONDING ELEMENT, AND MOVE VI TO END    OD 482
C----------OF BOUNDARY LIST                                               OD 483
                  LAST(VI) = EVI                                          OD 484
                  MARK(EVI) = -1                                          OD 485
                  L(TAIL) = LI                                            OD 486
                  TAIL = LI                                               OD 487
                  L(I) = L(LI)                                            OD 488
                  LI = I                                                  OD 489
                  GO TO 10                                                OD 490
C                                                                         OD 491
C----------ELSE IF VI IS DUPLICATE VERTEX, THEN MARK AS SUCH AND ADJUST   OD 492
C----------OVERLAP COUNT FOR CORRESPONDING ELEMENT                        OD 493
   8              LAST(VI) = 0                                            OD 494
                  MARK(EVI) = MARK(EVI) - 1                               OD 495
                  GO TO 10                                                OD 496
C                                                                         OD 497
C----------ELSE MARK VI TO COMPUTE DEGREE                                 OD 498
   9              LAST(VI) = -EK                                          OD 499
C                                                                         OD 500
C--------INSERT EK IN ELEMENT LIST OF VI                                  OD 501
  10        V(FREE) = EK                                                  OD 502
            L(FREE) = L(VI)                                               OD 503
            L(VI) = FREE                                                  OD 504
  11      CONTINUE                                                        OD 505
C                                                                         OD 506
C----TERMINATE BOUNDARY LIST                                              OD 507
  12    L(TAIL) = 0                                                       OD 508
C                                                                         OD 509
        RETURN                                                            OD 510
        END                                                               OD 511

        SUBROUTINE  NNF
     *     (N, R,C,IC, IA,JA,A, Z, B, IL,JL,L,LMAX, D, IU,JU,U,UMAX,      ND 523
     *      ROW, TMP, FLAG)                                               ND 524
C                                                                         ND 525
C       INPUT VARIABLES:   N, R,C,IC, IA,JA,A, B, IL,JL,LMAX, IU,JU,UMAX  ND 526
C       OUTPUT VARIABLES:  Z, L,D,U, FLAG                                 ND 527
C                                                                         ND 528
C       PARAMETERS USED INTERNALLY:                                       ND 529
C FIA   \ ROW   - HOLDS INTERMEDIATE VALUES IN CALCULATION OF L, D, U.    ND 530
C       \           SIZE = N.                                             ND 531
C FIA   \ TMP   - HOLDS NEW RIGHT-HAND SIDE B' FOR SOLUTION OF THE        ND 532
C       \           EQUATION  UX = B'.                                    ND 533
C       \           SIZE = N.                                             ND 534
C                                                                         ND 535
        INTEGER  R(1), C(1), IC(1),  IA(1), JA(1),                        ND 536
     *     IL(1), JL(1), LMAX,  IU(1), JU(1), UMAX,  FLAG                 ND 537
C       REAL  A(1), Z(1), B(1),  L(1), D(1), U(1),                        ND 538
C    *     ROW(1), TMP(1),  LI, SUM, DK                                   ND 539
        DOUBLE PRECISION  A(1), Z(1), B(1),  L(1), D(1), U(1),            ND 540
     *     ROW(1), TMP(1),  LI, SUM, DK                                   ND 541
C                                                                         ND 542
C  ******  CHECK STORAGE  **********************************************  ND 543
        IF (IL(N+1)-1 .GT. LMAX)  GO TO 104                               ND 544
        IF (IU(N+1)-1 .GT. UMAX)  GO TO 107                               ND 545
C                                                                         ND 546
C  ******  FOR EACH ROW  ***********************************************  ND 547
        DO 10 K=1,N                                                       ND 548
C  ******  SET THE INITIAL STRUCTURE OF ROW  ***************************  ND 549
          JMIN = IL(K)                                                    ND 550
          JMAX = IL(K+1) - 1                                              ND 551
          IF (JMIN.GT.JMAX)  GO TO 2                                      ND 552
C  ******  IF L(K,M) .NE. 0, ROW(M)=0  *********************************  ND 553
          DO 1 J=JMIN,JMAX                                                ND 554
   1        ROW(JL(J)) = 0                                                ND 555
   2      ROW(K) = 0                                                      ND 556
          JMIN = IU(K)                                                    ND 557
          JMAX = IU(K+1) - 1                                              ND 558
          IF (JMIN.GT.JMAX)  GO TO 4                                      ND 559
C  ******  IF U(K,M) .NE. 0, ROW(M)=0  *********************************  ND 560
          DO 3 J=JMIN,JMAX                                                ND 561
   3        ROW(JU(J)) = 0                                                ND 562
   4      JMIN = IA(R(K))                                                 ND 563
          JMAX = IA(R(K)+1) - 1                                           ND 564
C  ******  SET ROW TO KTH ROW OF REORDERED A  **************************  ND 565
          DO 5 J=JMIN,JMAX                                                ND 566
   5        ROW(IC(JA(J))) = A(J)                                         ND 567
C  ******  INITIALIZE SUM  *********************************************  ND 568
          SUM = B(R(K))                                                   ND 569
C                                                                         ND 570
C  ******  ASSIGN THE KTH ROW OF L AND ADJUST ROW, SUM  ****************  ND 571
          IMIN = IL(K)                                                    ND 572
          IMAX = IL(K+1) - 1                                              ND 573
          IF (IMIN.GT.IMAX)  GO TO 8                                      ND 574
          DO 7 I=IMIN,IMAX                                                ND 575
            LI = - ROW(JL(I))                                             ND 576
C  ******  IF L IS NOT REQUIRED, THEN COMMENT OUT THE FOLLOWING LINE  **  ND 577
            L(I) = - LI                                                   ND 578
            SUM = SUM + LI * TMP(JL(I))                                   ND 579
            JMIN = IU(JL(I))                                              ND 580
            JMAX = IU(JL(I)+1) - 1                                        ND 581
            IF (JMIN.GT.JMAX)  GO TO 7                                    ND 582
            DO 6 J=JMIN,JMAX                                              ND 583
   6          ROW(JU(J)) = ROW(JU(J)) + LI * U(J)                         ND 584
   7        CONTINUE                                                      ND 585
C                                                                         ND 586
C  ******  ASSIGN DIAGONAL D AND KTH ROW OF U, SET TMP(K)  *************  ND 587
   8      IF (ROW(K).EQ.0)  GO TO 108                                     ND 588
          DK = 1 / ROW(K)                                                 ND 589
          D(K) = DK                                                       ND 590
          TMP(K) = SUM * DK                                               ND 591
          JMIN = IU(K)                                                    ND 592
          JMAX = IU(K+1) - 1                                              ND 593
          IF (JMIN.GT.JMAX)  GO TO 10                                     ND 594
          DO 9 J=JMIN,JMAX                                                ND 595
   9        U(J) = ROW(JU(J)) * DK                                        ND 596
  10      CONTINUE                                                        ND 597
C                                                                         ND 598
C  ******  SOLVE  UX = TMP  BY BACK SUBSTITUTION  **********************  ND 599
        K = N                                                             ND 600
        DO 13 I=1,N                                                       ND 601
          SUM = TMP(K)                                                    ND 602
          JMIN = IU(K)                                                    ND 603
          JMAX = IU(K+1) - 1                                              ND 604
          IF (JMIN.GT.JMAX)  GO TO 12                                     ND 605
          DO 11 J=JMIN,JMAX                                               ND 606
  11        SUM = SUM - U(J) * TMP(JU(J))                                 ND 607
  12      TMP(K) = SUM                                                    ND 608
          Z(C(K)) = SUM                                                   ND 609
  13      K = K-1                                                         ND 610
C                                                                         ND 611
        FLAG = 0                                                          ND 612
        RETURN                                                            ND 613
C                                                                         ND 614
C ** ERROR:  INSUFFICIENT STORAGE FOR L                                   ND 615
 104    FLAG = 4*N + 1                                                    ND 616
        RETURN                                                            ND 617
C ** ERROR:  INSUFFICIENT STORAGE FOR U                                   ND 618
 107    FLAG = 7*N + 1                                                    ND 619
        RETURN                                                            ND 620
C ** ERROR:  ZERO PIVOT                                                   ND 621
 108    FLAG = 8*N + K                                                    ND 622
        RETURN                                                            ND 623
        END                                                               ND 624

        SUBROUTINE NNTC
     *     (N, R, C, IL, JL, IJL, L, D, IU, JU, IJU, U, Z, B, TMP)        CD1056
C                                                                         CD1057
C       INPUT VARIABLES:   N, R, C, IL, JL, IJL, L, D, IU, JU, IJU, U, B  CD1058
C       OUTPUT VARIABLES:  Z                                              CD1059
C                                                                         CD1060
C       PARAMETERS USED INTERNALLY:                                       CD1061
C FIA   \ TMP   - TEMPORARY VECTOR WHICH GETS RESULT OF SOLVING UT Y = B  CD1062
C       \           SIZE = N.                                             CD1063
C                                                                         CD1064
C  INTERNAL VARIABLES:                                                    CD1065
C    JMIN, JMAX - INDICES OF THE FIRST AND LAST POSITIONS IN A ROW OF     CD1066
C      U OR L  TO BE USED.                                                CD1067
C                                                                         CD1068
        INTEGER R(1), C(1), IL(1), JL(1), IJL(1), IU(1), JU(1), IJU(1)    CD1069
C       REAL L(1), D(1), U(1), B(1), Z(1), TMP(1), TMPK,SUM               CD1070
        DOUBLE PRECISION L(1), D(1), U(1), B(1), Z(1), TMP(1), TMPK,SUM   CD1071
C                                                                         CD1072
C  ******  SET TMP TO REORDERED B  *************************************  CD1073
        DO 1 K=1,N                                                        CD1074
   1      TMP(K) = B(C(K))                                                CD1075
C  ******  SOLVE  UT Y = B  BY FORWARD SUBSTITUTION  *******************  CD1076
        DO 3 K=1,N                                                        CD1077
          JMIN = IU(K)                                                    CD1078
          JMAX = IU(K+1) - 1                                              CD1079
          TMPK = -TMP(K)                                                  CD1080
          IF (JMIN .GT. JMAX) GO TO 3                                     CD1081
          MU = IJU(K) - JMIN                                              CD1082
          DO 2 J=JMIN,JMAX                                                CD1083
   2        TMP(JU(MU+J)) = TMP(JU(MU+J)) + TMPK * U(J)                   CD1084
   3      CONTINUE                                                        CD1085
C  ******  SOLVE  LT X = Y  BY BACK SUBSTITUTION  **********************  CD1086
        K = N                                                             CD1087
        DO 6 I=1,N                                                        CD1088
          SUM = -TMP(K)                                                   CD1089
          JMIN = IL(K)                                                    CD1090
          JMAX = IL(K+1) - 1                                              CD1091
          IF (JMIN .GT. JMAX) GO TO 5                                     CD1092
          ML = IJL(K) - JMIN                                              CD1093
          DO 4 J=JMIN,JMAX                                                CD1094
   4        SUM = SUM + L(J) * TMP(JL(ML+J))                              CD1095
   5      TMP(K) = -SUM * D(K)                                            CD1096
          Z(R(K)) = TMP(K)                                                CD1097
          K = K - 1                                                       CD1098
   6      CONTINUE                                                        CD1099
        RETURN                                                            CD1100
        END                                                               CD1101

        SUBROUTINE  MD
     *     (N, IA,JA, MAX, V,L, HEAD,LAST,NEXT, MARK, FLAG)               OD 175
C                                                                         OD 176
C  DESCRIPTION                                                            OD 177
C                                                                         OD 178
C    MD FINDS A MINIMUM DEGREE ORDERING OF THE ROWS AND COLUMNS OF A      OD 179
C    SYMMETRIC MATRIX M STORED IN (IA,JA,A) FORMAT.                       OD 180
C                                                                         OD 181
C                                                                         OD 182
C  ADDITIONAL PARAMETERS                                                  OD 183
C                                                                         OD 184
C    MAX  - DECLARED DIMENSION OF THE ONE-DIMENSIONAL ARRAYS V AND L;     OD 185
C           MAX MUST BE AT LEAST  N+2K,  WHERE K IS THE NUMBER OF         OD 186
C           NONZEROES IN THE STRICT UPPER TRIANGLE OF M                   OD 187
C                                                                         OD 188
C    V    - INTEGER ONE-DIMENSIONAL WORK ARRAY;  DIMENSION = MAX          OD 189
C                                                                         OD 190
C    L    - INTEGER ONE-DIMENSIONAL WORK ARRAY;  DIMENSION = MAX          OD 191
C                                                                         OD 192
C    HEAD - INTEGER ONE-DIMENSIONAL WORK ARRAY;  DIMENSION = N            OD 193
C                                                                         OD 194
C    LAST - INTEGER ONE-DIMENSIONAL ARRAY USED TO RETURN THE PERMUTATION  OD 195
C           OF THE ROWS AND COLUMNS OF M CORRESPONDING TO THE MINIMUM     OD 196
C           DEGREE ORDERING;  DIMENSION = N                               OD 197
C                                                                         OD 198
C    NEXT - INTEGER ONE-DIMENSIONAL ARRAY USED TO RETURN THE INVERSE OF   OD 199
C           THE PERMUTATION RETURNED IN LAST;  DIMENSION = N              OD 200
C                                                                         OD 201
C    MARK - INTEGER ONE-DIMENSIONAL WORK ARRAY (MAY BE THE SAME AS V);    OD 202
C           DIMENSION = N                                                 OD 203
C                                                                         OD 204
C    FLAG - INTEGER ERROR FLAG;  VALUES AND THEIR MEANINGS ARE -          OD 205
C             0      NO ERRORS DETECTED                                   OD 206
C             11N+1  INSUFFICIENT STORAGE IN MD                           OD 207
C                                                                         OD 208
C                                                                         OD 209
C  DEFINITIONS OF INTERNAL PARAMETERS                                     OD 210
C                                                                         OD 211
C    ---------+---------------------------------------------------------  OD 212
C    V(S)     \ VALUE FIELD OF LIST ENTRY                                 OD 213
C    ---------+---------------------------------------------------------  OD 214
C    L(S)     \ LINK FIELD OF LIST ENTRY  (0 => END OF LIST)              OD 215
C    ---------+---------------------------------------------------------  OD 216
C    L(VI)    \ POINTER TO ELEMENT LIST OF UNELIMINATED VERTEX VI         OD 217
C    ---------+---------------------------------------------------------  OD 218
C    L(EJ)    \ POINTER TO BOUNDARY LIST OF ACTIVE ELEMENT EJ             OD 219
C    ---------+---------------------------------------------------------  OD 220
C    HEAD(D)  \ VJ => VJ HEAD OF D-LIST D                                 OD 221
C             \  0 => NO VERTEX IN D-LIST D                               OD 222
C                                                                         OD 223
C                                                                         OD 224
C             \                  VI UNELIMINATED VERTEX                   OD 225
C             \          VI IN EK           \       VI NOT IN EK          OD 226
C    ---------+-----------------------------+---------------------------  OD 227
C    NEXT(VI) \ UNDEFINED BUT NONNEGATIVE   \ VJ => VJ NEXT IN D-LIST     OD 228
C             \                             \  0 => VI TAIL OF D-LIST     OD 229
C    ---------+-----------------------------+---------------------------  OD 230
C    LAST(VI) \ (NOT SET UNTIL MDP)         \ -D => VI HEAD OF D-LIST D   OD 231
C             \-VK => COMPUTE DEGREE        \ VJ => VJ LAST IN D-LIST     OD 232
C             \ EJ => VI PROTOTYPE OF EJ    \  0 => VI NOT IN ANY D-LIST  OD 233
C             \  0 => DO NOT COMPUTE DEGREE \                             OD 234
C    ---------+-----------------------------+---------------------------  OD 235
C    MARK(VI) \ MARK(VK)                    \ NONNEGATIVE TAG < MARK(VK)  OD 236
C                                                                         OD 237
C                                                                         OD 238
C             \                   VI ELIMINATED VERTEX                    OD 239
C             \      EI ACTIVE ELEMENT      \           OTHERWISE         OD 240
C    ---------+-----------------------------+---------------------------  OD 241
C    NEXT(VI) \ -J => VI WAS J-TH VERTEX    \ -J => VI WAS J-TH VERTEX    OD 242
C             \       TO BE ELIMINATED      \       TO BE ELIMINATED      OD 243
C    ---------+-----------------------------+---------------------------  OD 244
C    LAST(VI) \  M => SIZE OF EI = M        \ UNDEFINED                   OD 245
C    ---------+-----------------------------+---------------------------  OD 246
C    MARK(VI) \ -M => OVERLAP COUNT OF EI   \ UNDEFINED                   OD 247
C             \       WITH EK = M           \                             OD 248
C             \ OTHERWISE NONNEGATIVE TAG   \                             OD 249
C             \       < MARK(VK)            \                             OD 250
C                                                                         OD 251
C-----------------------------------------------------------------------  OD 252
C                                                                         OD 253
        INTEGER  IA(1), JA(1),  V(1), L(1),  HEAD(1), LAST(1), NEXT(1),   OD 254
     *     MARK(1),  FLAG,  TAG, DMIN, VK,EK, TAIL                        OD 255
        EQUIVALENCE  (VK,EK)                                              OD 256
C                                                                         OD 257
C----INITIALIZATION                                                       OD 258
        TAG = 0                                                           OD 259
        CALL  MDI                                                         OD 260
     *     (N, IA,JA, MAX,V,L, HEAD,LAST,NEXT, MARK,TAG, FLAG)            OD 261
        IF (FLAG.NE.0)  RETURN                                            OD 262
C                                                                         OD 263
        K = 0                                                             OD 264
        DMIN = 1                                                          OD 265
C                                                                         OD 266
C----WHILE  K < N  DO                                                     OD 267
   1    IF (K.GE.N)  GO TO 4                                              OD 268
C                                                                         OD 269
C------SEARCH FOR VERTEX OF MINIMUM DEGREE                                OD 270
   2      IF (HEAD(DMIN).GT.0)  GO TO 3                                   OD 271
            DMIN = DMIN + 1                                               OD 272
            GO TO 2                                                       OD 273
C                                                                         OD 274
C------REMOVE VERTEX VK OF MINIMUM DEGREE FROM DEGREE LIST                OD 275
   3      VK = HEAD(DMIN)                                                 OD 276
          HEAD(DMIN) = NEXT(VK)                                           OD 277
          IF (HEAD(DMIN).GT.0)  LAST(HEAD(DMIN)) = -DMIN                  OD 278
C                                                                         OD 279
C------NUMBER VERTEX VK, ADJUST TAG, AND TAG VK                           OD 280
          K = K+1                                                         OD 281
          NEXT(VK) = -K                                                   OD 282
          LAST(EK) = DMIN - 1                                             OD 283
          TAG = TAG + LAST(EK)                                            OD 284
          MARK(VK) = TAG                                                  OD 285
C                                                                         OD 286
C------FORM ELEMENT EK FROM UNELIMINATED NEIGHBORS OF VK                  OD 287
          CALL  MDM                                                       OD 288
     *       (VK,TAIL, V,L, LAST,NEXT, MARK)                              OD 289
C                                                                         OD 290
C------PURGE INACTIVE ELEMENTS AND DO MASS ELIMINATION                    OD 291
          CALL  MDP                                                       OD 292
     *       (K,EK,TAIL, V,L, HEAD,LAST,NEXT, MARK)                       OD 293
C                                                                         OD 294
C------UPDATE DEGREES OF UNELIMINATED VERTICES IN EK                      OD 295
          CALL  MDU                                                       OD 296
     *       (EK,DMIN, V,L, HEAD,LAST,NEXT, MARK)                         OD 297
C                                                                         OD 298
          GO TO 1                                                         OD 299
C                                                                         OD 300
C----GENERATE INVERSE PERMUTATION FROM PERMUTATION                        OD 301
   4    DO 5 K=1,N                                                        OD 302
          NEXT(K) = -NEXT(K)                                              OD 303
   5      LAST(NEXT(K)) = K                                               OD 304
C                                                                         OD 305
        RETURN                                                            OD 306
        END                                                               OD 307

        SUBROUTINE NROC (N, IC, IA, JA, A, JAR, AR, P, FLAG)
C                                                                         CD 452
C       INPUT PARAMETERS: N, IC, IA, JA, A                                CD 453
C       OUTPUT PARAMETERS: JA, A, FLAG                                    CD 454
C                                                                         CD 455
C       PARAMETERS USED INTERNALLY:                                       CD 456
C NIA   \ P     - AT THE KTH STEP, P IS A LINKED LIST OF THE REORDERED    CD 457
C       \           COLUMN INDICES OF THE KTH ROW OF A;  P(N+1) POINTS    CD 458
C       \           TO THE FIRST ENTRY IN THE LIST.                       CD 459
C       \           SIZE = N+1.                                           CD 460
C NIA   \ JAR   - AT THE KTH STEP,JAR CONTAINS THE ELEMENTS OF THE        CD 461
C       \           REORDERED COLUMN INDICES OF A.                        CD 462
C       \           SIZE = N.                                             CD 463
C FIA   \ AR    - AT THE KTH STEP, AR CONTAINS THE ELEMENTS OF THE        CD 464
C       \           REORDERED ROW OF A.                                   CD 465
C       \           SIZE = N.                                             CD 466
C                                                                         CD 467
        INTEGER  IC(1), IA(1), JA(1), JAR(1), P(1), FLAG                  CD 468
C       REAL  A(1), AR(1)                                                 CD 469
        DOUBLE PRECISION  A(1), AR(1)                                     CD 470
C                                                                         CD 471
C  ******  FOR EACH NONEMPTY ROW  *******************************         CD 472
        DO 5 K=1,N                                                        CD 473
          JMIN = IA(K)                                                    CD 474
          JMAX = IA(K+1) - 1                                              CD 475
          IF(JMIN .GT. JMAX) GO TO 5                                      CD 476
          P(N+1) = N + 1                                                  CD 477
C  ******  INSERT EACH ELEMENT IN THE LIST  *********************         CD 478
          DO 3 J=JMIN,JMAX                                                CD 479
            NEWJ = IC(JA(J))                                              CD 480
            I = N + 1                                                     CD 481
   1        IF(P(I) .GE. NEWJ) GO TO 2                                    CD 482
              I = P(I)                                                    CD 483
              GO TO 1                                                     CD 484
   2        IF(P(I) .EQ. NEWJ) GO TO 102                                  CD 485
            P(NEWJ) = P(I)                                                CD 486
            P(I) = NEWJ                                                   CD 487
            JAR(NEWJ) = JA(J)                                             CD 488
            AR(NEWJ) = A(J)                                               CD 489
   3        CONTINUE                                                      CD 490
C  ******  REPLACE OLD ROW IN JA AND A  *************************         CD 491
          I = N + 1                                                       CD 492
          DO 4 J=JMIN,JMAX                                                CD 493
            I = P(I)                                                      CD 494
            JA(J) = JAR(I)                                                CD 495
   4        A(J) = AR(I)                                                  CD 496
   5      CONTINUE                                                        CD 497
        FLAG = 0                                                          CD 498
        RETURN                                                            CD 499
C                                                                         CD 500
C ** ERROR:  DUPLICATE ENTRY IN A                                         CD 501
 102    FLAG = N + K                                                      CD 502
        RETURN                                                            CD 503
        END                                                               CD 504

        SUBROUTINE  MDM
     *     (VK,TAIL, V,L, LAST,NEXT, MARK)                                OD 371
        INTEGER  VK, TAIL,  V(1), L(1),   LAST(1), NEXT(1),   MARK(1),    OD 372
     *     TAG, S,LS,VS,ES, B,LB,VB, BLP,BLPMAX                           OD 373
        EQUIVALENCE  (VS, ES)                                             OD 374
C                                                                         OD 375
C----INITIALIZE TAG AND LIST OF UNELIMINATED NEIGHBORS                    OD 376
        TAG = MARK(VK)                                                    OD 377
        TAIL = VK                                                         OD 378
C                                                                         OD 379
C----FOR EACH VERTEX/ELEMENT VS/ES IN ELEMENT LIST OF VK                  OD 380
        LS = L(VK)                                                        OD 381
   1    S = LS                                                            OD 382
        IF (S.EQ.0)  GO TO 5                                              OD 383
          LS = L(S)                                                       OD 384
          VS = V(S)                                                       OD 385
          IF (NEXT(VS).LT.0)  GO TO 2                                     OD 386
C                                                                         OD 387
C------IF VS IS UNELIMINATED VERTEX, THEN TAG AND APPEND TO LIST OF       OD 388
C------UNELIMINATED NEIGHBORS                                             OD 389
            MARK(VS) = TAG                                                OD 390
            L(TAIL) = S                                                   OD 391
            TAIL = S                                                      OD 392
            GO TO 4                                                       OD 393
C                                                                         OD 394
C------IF ES IS ACTIVE ELEMENT, THEN ...                                  OD 395
C--------FOR EACH VERTEX VB IN BOUNDARY LIST OF ELEMENT ES                OD 396
   2        LB = L(ES)                                                    OD 397
            BLPMAX = LAST(ES)                                             OD 398
            DO 3 BLP=1,BLPMAX                                             OD 399
              B = LB                                                      OD 400
              LB = L(B)                                                   OD 401
              VB = V(B)                                                   OD 402
C                                                                         OD 403
C----------IF VB IS UNTAGGED VERTEX, THEN TAG AND APPEND TO LIST OF       OD 404
C----------UNELIMINATED NEIGHBORS                                         OD 405
              IF (MARK(VB).GE.TAG)  GO TO 3                               OD 406
                MARK(VB) = TAG                                            OD 407
                L(TAIL) = B                                               OD 408
                TAIL = B                                                  OD 409
   3          CONTINUE                                                    OD 410
C                                                                         OD 411
C--------MARK ES INACTIVE                                                 OD 412
            MARK(ES) = TAG                                                OD 413
C                                                                         OD 414
   4      GO TO 1                                                         OD 415
C                                                                         OD 416
C----TERMINATE LIST OF UNELIMINATED NEIGHBORS                             OD 417
   5    L(TAIL) = 0                                                       OD 418
C                                                                         OD 419
        RETURN                                                            OD 420
        END                                                               OD 421

        SUBROUTINE  MDU
     *     (EK,DMIN, V,L, HEAD,LAST,NEXT, MARK)                           OD 517
        INTEGER  EK, DMIN,  V(1), L(1),  HEAD(1), LAST(1), NEXT(1),       OD 518
     *     MARK(1),  TAG, VI,EVI,DVI, S,VS,ES, B,VB, ILP,ILPMAX,          OD 519
     *     BLP,BLPMAX                                                     OD 520
        EQUIVALENCE  (VS, ES)                                             OD 521
C                                                                         OD 522
C----INITIALIZE TAG                                                       OD 523
        TAG = MARK(EK) - LAST(EK)                                         OD 524
C                                                                         OD 525
C----FOR EACH VERTEX VI IN EK                                             OD 526
        I = EK                                                            OD 527
        ILPMAX = LAST(EK)                                                 OD 528
        IF (ILPMAX.LE.0)  GO TO 11                                        OD 529
        DO 10 ILP=1,ILPMAX                                                OD 530
          I = L(I)                                                        OD 531
          VI = V(I)                                                       OD 532
          IF (LAST(VI))  1, 10, 8                                         OD 533
C                                                                         OD 534
C------IF VI NEITHER PROTOTYPE NOR DUPLICATE VERTEX, THEN MERGE ELEMENTS  OD 535
C------TO COMPUTE DEGREE                                                  OD 536
   1        TAG = TAG + 1                                                 OD 537
            DVI = LAST(EK)                                                OD 538
C                                                                         OD 539
C--------FOR EACH VERTEX/ELEMENT VS/ES IN ELEMENT LIST OF VI              OD 540
            S = L(VI)                                                     OD 541
   2        S = L(S)                                                      OD 542
            IF (S.EQ.0)  GO TO 9                                          OD 543
              VS = V(S)                                                   OD 544
              IF (NEXT(VS).LT.0)  GO TO 3                                 OD 545
C                                                                         OD 546
C----------IF VS IS UNELIMINATED VERTEX, THEN TAG AND ADJUST DEGREE       OD 547
                MARK(VS) = TAG                                            OD 548
                DVI = DVI + 1                                             OD 549
                GO TO 5                                                   OD 550
C                                                                         OD 551
C----------IF ES IS ACTIVE ELEMENT, THEN EXPAND                           OD 552
C------------CHECK FOR OUTMATCHED VERTEX                                  OD 553
   3            IF (MARK(ES).LT.0)  GO TO 6                               OD 554
C                                                                         OD 555
C------------FOR EACH VERTEX VB IN ES                                     OD 556
                B = ES                                                    OD 557
                BLPMAX = LAST(ES)                                         OD 558
                DO 4 BLP=1,BLPMAX                                         OD 559
                  B = L(B)                                                OD 560
                  VB = V(B)                                               OD 561
C                                                                         OD 562
C--------------IF VB IS UNTAGGED, THEN TAG AND ADJUST DEGREE              OD 563
                  IF (MARK(VB).GE.TAG)  GO TO 4                           OD 564
                    MARK(VB) = TAG                                        OD 565
                    DVI = DVI + 1                                         OD 566
   4              CONTINUE                                                OD 567
C                                                                         OD 568
   5          GO TO 2                                                     OD 569
C                                                                         OD 570
C------ELSE IF VI IS OUTMATCHED VERTEX, THEN ADJUST OVERLAPS BUT DO NOT   OD 571
C------COMPUTE DEGREE                                                     OD 572
   6        LAST(VI) = 0                                                  OD 573
            MARK(ES) = MARK(ES) - 1                                       OD 574
   7        S = L(S)                                                      OD 575
            IF (S.EQ.0)  GO TO 10                                         OD 576
              ES = V(S)                                                   OD 577
              IF (MARK(ES).LT.0)  MARK(ES) = MARK(ES) - 1                 OD 578
              GO TO 7                                                     OD 579
C                                                                         OD 580
C------ELSE IF VI IS PROTOTYPE VERTEX, THEN CALCULATE DEGREE BY           OD 581
C------INCLUSION/EXCLUSION AND RESET OVERLAP COUNT                        OD 582
   8        EVI = LAST(VI)                                                OD 583
            DVI = LAST(EK) + LAST(EVI) + MARK(EVI)                        OD 584
            MARK(EVI) = 0                                                 OD 585
C                                                                         OD 586
C------INSERT VI IN APPROPRIATE DEGREE LIST                               OD 587
   9      NEXT(VI) = HEAD(DVI)                                            OD 588
          HEAD(DVI) = VI                                                  OD 589
          LAST(VI) = -DVI                                                 OD 590
          IF (NEXT(VI).GT.0)  LAST(NEXT(VI)) = VI                         OD 591
          IF (DVI.LT.DMIN)  DMIN = DVI                                    OD 592
C                                                                         OD 593
  10      CONTINUE                                                        OD 594
C                                                                         OD 595
  11    RETURN                                                            OD 596
        END                                                               OD 597

        SUBROUTINE  MDI
     *     (N, IA,JA, MAX,V,L, HEAD,LAST,NEXT, MARK,TAG, FLAG)            OD 313
        INTEGER  IA(1), JA(1),  V(1), L(1),  HEAD(1), LAST(1), NEXT(1),   OD 314
     *     MARK(1), TAG,  FLAG,  SFS, VI,DVI, VJ                          OD 315
C                                                                         OD 316
C----INITIALIZE DEGREES, ELEMENT LISTS, AND DEGREE LISTS                  OD 317
        DO 1 VI=1,N                                                       OD 318
          MARK(VI) = 1                                                    OD 319
          L(VI) = 0                                                       OD 320
   1      HEAD(VI) = 0                                                    OD 321
        SFS = N+1                                                         OD 322
C                                                                         OD 323
C----CREATE NONZERO STRUCTURE                                             OD 324
C----FOR EACH NONZERO ENTRY A(VI,VJ) IN STRICT UPPER TRIANGLE             OD 325
        DO 3 VI=1,N                                                       OD 326
          JMIN = IA(VI)                                                   OD 327
          JMAX = IA(VI+1) - 1                                             OD 328
          IF (JMIN.GT.JMAX)  GO TO 3                                      OD 329
          DO 2 J=JMIN,JMAX                                                OD 330
            VJ = JA(J)                                                    OD 331
            IF (VI.GE.VJ)  GO TO 2                                        OD 332
              IF (SFS.GE.MAX)  GO TO 101                                  OD 333
C                                                                         OD 334
C------ENTER VJ IN ELEMENT LIST FOR VI                                    OD 335
              MARK(VI) = MARK(VI) + 1                                     OD 336
              V(SFS) = VJ                                                 OD 337
              L(SFS) = L(VI)                                              OD 338
              L(VI) = SFS                                                 OD 339
              SFS = SFS+1                                                 OD 340
C                                                                         OD 341
C------ENTER VI IN ELEMENT LIST FOR VJ                                    OD 342
              MARK(VJ) = MARK(VJ) + 1                                     OD 343
              V(SFS) = VI                                                 OD 344
              L(SFS) = L(VJ)                                              OD 345
              L(VJ) = SFS                                                 OD 346
              SFS = SFS+1                                                 OD 347
   2        CONTINUE                                                      OD 348
   3      CONTINUE                                                        OD 349
C                                                                         OD 350
C----CREATE DEGREE LISTS AND INITIALIZE MARK VECTOR                       OD 351
        DO 4 VI=1,N                                                       OD 352
          DVI = MARK(VI)                                                  OD 353
          NEXT(VI) = HEAD(DVI)                                            OD 354
          HEAD(DVI) = VI                                                  OD 355
          LAST(VI) = -DVI                                                 OD 356
          IF (NEXT(VI).GT.0)  LAST(NEXT(VI)) = VI                         OD 357
   4      MARK(VI) = TAG                                                  OD 358
C                                                                         OD 359
        RETURN                                                            OD 360
C                                                                         OD 361
C ** ERROR -- INSUFFICIENT STORAGE                                        OD 362
 101    FLAG = 9*N + VI                                                   OD 363
        RETURN                                                            OD 364
        END                                                               OD 365

        SUBROUTINE  CDRV
     *     (N, R,C,IC, IA,JA,A, B, Z, NSP,ISP,RSP,ESP, PATH, FLAG)        CD  12
C                                                                         CD  13
C    PARAMETERS                                                           CD  14
C    CLASS ABBREVIATIONS ARE--                                            CD  15
C       N - INTEGER VARIABLE                                              CD  16
C       F - REAL VARIABLE                                                 CD  17
C       V - SUPPLIES A VALUE TO THE DRIVER                                CD  18
C       R - RETURNS A RESULT FROM THE DRIVER                              CD  19
C       I - USED INTERNALLY BY THE DRIVER                                 CD  20
C       A - ARRAY                                                         CD  21
C                                                                         CD  22
C CLASS \ PARAMETER                                                       CD  23
C ------+----------                                                       CD  24
C       \                                                                 CD  25
C         THE NONZERO ENTRIES OF THE COEFFICIENT MATRIX M ARE STORED      CD  26
C    ROW-BY-ROW IN THE ARRAY A.  TO IDENTIFY THE INDIVIDUAL NONZERO       CD  27
C    ENTRIES IN EACH ROW, WE NEED TO KNOW IN WHICH COLUMN EACH ENTRY      CD  28
C    LIES.  THE COLUMN INDICES WHICH CORRESPOND TO THE NONZERO ENTRIES    CD  29
C    OF M ARE STORED IN THE ARRAY JA;  I.E., IF  A(K) = M(I,J),  THEN     CD  30
C    JA(K) = J.  IN ADDITION, WE NEED TO KNOW WHERE EACH ROW STARTS AND   CD  31
C    HOW LONG IT IS.  THE INDEX POSITIONS IN JA AND A WHERE THE ROWS OF   CD  32
C    M BEGIN ARE STORED IN THE ARRAY IA;  I.E., IF M(I,J) IS THE FIRST    CD  33
C    NONZERO ENTRY (STORED) IN THE I-TH ROW AND A(K) = M(I,J),  THEN      CD  34
C    IA(I) = K.  MOREOVER, THE INDEX IN JA AND A OF THE FIRST LOCATION    CD  35
C    FOLLOWING THE LAST ELEMENT IN THE LAST ROW IS STORED IN IA(N+1).     CD  36
C    THUS, THE NUMBER OF ENTRIES IN THE I-TH ROW IS GIVEN BY              CD  37
C    IA(I+1) - IA(I),  THE NONZERO ENTRIES OF THE I-TH ROW ARE STORED     CD  38
C    CONSECUTIVELY IN                                                     CD  39
C            A(IA(I)),  A(IA(I)+1),  ..., A(IA(I+1)-1),                   CD  40
C    AND THE CORRESPONDING COLUMN INDICES ARE STORED CONSECUTIVELY IN     CD  41
C            JA(IA(I)), JA(IA(I)+1), ..., JA(IA(I+1)-1).                  CD  42
C    FOR EXAMPLE, THE 5 BY 5 MATRIX                                       CD  43
C                ( 1. 0. 2. 0. 0.)                                        CD  44
C                ( 0. 3. 0. 0. 0.)                                        CD  45
C            M = ( 0. 4. 5. 6. 0.)                                        CD  46
C                ( 0. 0. 0. 7. 0.)                                        CD  47
C                ( 0. 0. 0. 8. 9.)                                        CD  48
C    WOULD BE STORED AS                                                   CD  49
C               \ 1  2  3  4  5  6  7  8  9                               CD  50
C            ---+--------------------------                               CD  51
C            IA \ 1  3  4  7  8 10                                        CD  52
C            JA \ 1  3  2  2  3  4  4  4  5                               CD  53
C             A \ 1. 2. 3. 4. 5. 6. 7. 8. 9.         .                    CD  54
C                                                                         CD  55
C NV    \ N     - NUMBER OF VARIABLES/EQUATIONS.                          CD  56
C FVA   \ A     - NONZERO ENTRIES OF THE COEFFICIENT MATRIX M, STORED     CD  57
C       \           BY ROWS.                                              CD  58
C       \           SIZE = NUMBER OF NONZERO ENTRIES IN M.                CD  59
C NVA   \ IA    - POINTERS TO DELIMIT THE ROWS IN A.                      CD  60
C       \           SIZE = N+1.                                           CD  61
C NVA   \ JA    - COLUMN NUMBERS CORRESPONDING TO THE ELEMENTS OF A.      CD  62
C       \           SIZE = SIZE OF A.                                     CD  63
C FVA   \ B     - RIGHT-HAND SIDE B;  B AND Z CAN THE SAME ARRAY.         CD  64
C       \           SIZE = N.                                             CD  65
C FRA   \ Z     - SOLUTION X;  B AND Z CAN BE THE SAME ARRAY.             CD  66
C       \           SIZE = N.                                             CD  67
C                                                                         CD  68
C         THE ROWS AND COLUMNS OF THE ORIGINAL MATRIX M CAN BE            CD  69
C    REORDERED (E.G., TO REDUCE FILLIN OR ENSURE NUMERICAL STABILITY)     CD  70
C    BEFORE CALLING THE DRIVER.  IF NO REORDERING IS DONE, THEN SET       CD  71
C    R(I) = C(I) = IC(I) = I  FOR I=1,...,N.  THE SOLUTION Z IS RETURNED  CD  72
C    IN THE ORIGINAL ORDER.                                               CD  73
C         IF THE COLUMNS HAVE BEEN REORDERED (I.E.,  C(I).NE.I  FOR SOME  CD  74
C    I), THEN THE DRIVER WILL CALL A SUBROUTINE (NROC) WHICH REARRANGES   CD  75
C    EACH ROW OF JA AND A, LEAVING THE ROWS IN THE ORIGINAL ORDER, BUT    CD  76
C    PLACING THE ELEMENTS OF EACH ROW IN INCREASING ORDER WITH RESPECT    CD  77
C    TO THE NEW ORDERING.  IF  PATH.NE.1,  THEN NROC IS ASSUMED TO HAVE   CD  78
C    BEEN CALLED ALREADY.                                                 CD  79
C                                                                         CD  80
C NVA   \ R     - ORDERING OF THE ROWS OF M.                              CD  81
C       \           SIZE = N.                                             CD  82
C NVA   \ C     - ORDERING OF THE COLUMNS OF M.                           CD  83
C       \           SIZE = N.                                             CD  84
C NVA   \ IC    - INVERSE OF THE ORDERING OF THE COLUMNS OF M;  I.E.,     CD  85
C       \           IC(C(I)) = I  FOR I=1,...,N.                          CD  86
C       \           SIZE = N.                                             CD  87
C                                                                         CD  88
C         THE SOLUTION OF THE SYSTEM OF LINEAR EQUATIONS IS DIVIDED INTO  CD  89
C    THREE STAGES --                                                      CD  90
C      NSFC -- THE MATRIX M IS PROCESSED SYMBOLICALLY TO DETERMINE WHERE  CD  91
C               FILLIN WILL OCCUR DURING THE NUMERIC FACTORIZATION.       CD  92
C      NNFC -- THE MATRIX M IS FACTORED NUMERICALLY INTO THE PRODUCT LDU  CD  93
C               OF A UNIT LOWER TRIANGULAR MATRIX L, A DIAGONAL MATRIX    CD  94
C               D, AND A UNIT UPPER TRIANGULAR MATRIX U, AND THE SYSTEM   CD  95
C               MX = B  IS SOLVED.                                        CD  96
C      NNSC -- THE LINEAR SYSTEM  MX = B  IS SOLVED USING THE LDU         CD  97
C  OR           FACTORIZATION FROM NNFC.                                  CD  98
C      NNTC -- THE TRANSPOSED LINEAR SYSTEM  MT X = B  IS SOLVED USING    CD  99
C               THE LDU FACTORIZATION FROM NNF.                           CD 100
C    FOR SEVERAL SYSTEMS WHOSE COEFFICIENT MATRICES HAVE THE SAME         CD 101
C    NONZERO STRUCTURE, NSFC NEED BE DONE ONLY ONCE (FOR THE FIRST        CD 102
C    SYSTEM);  THEN NNFC IS DONE ONCE FOR EACH ADDITIONAL SYSTEM.  FOR    CD 103
C    SEVERAL SYSTEMS WITH THE SAME COEFFICIENT MATRIX, NSFC AND NNFC      CD 104
C    NEED BE DONE ONLY ONCE (FOR THE FIRST SYSTEM);  THEN NNSC OR NNTC    CD 105
C    IS DONE ONCE FOR EACH ADDITIONAL RIGHT-HAND SIDE.                    CD 106
C                                                                         CD 107
C NV    \ PATH  - PATH SPECIFICATION;  VALUES AND THEIR MEANINGS ARE --   CD 108
C       \           1  PERFORM NROC, NSFC, AND NNFC.                      CD 109
C       \           2  PERFORM NNFC ONLY  (NSFC IS ASSUMED TO HAVE BEEN   CD 110
C       \               DONE IN A MANNER COMPATIBLE WITH THE STORAGE      CD 111
C       \               ALLOCATION USED IN THE DRIVER).                   CD 112
C       \           3  PERFORM NNSC ONLY  (NSFC AND NNFC ARE ASSUMED TO   CD 113
C       \               HAVE BEEN DONE IN A MANNER COMPATIBLE WITH THE    CD 114
C       \               STORAGE ALLOCATION USED IN THE DRIVER).           CD 115
C       \           4  PERFORM NNTC ONLY  (NSFC AND NNFC ARE ASSUMED TO   CD 116
C       \               HAVE BEEN DONE IN A MANNER COMPATIBLE WITH THE    CD 117
C       \               STORAGE ALLOCATION USED IN THE DRIVER).           CD 118
C       \           5  PERFORM NROC AND NSFC.                             CD 119
C                                                                         CD 120
C         VARIOUS ERRORS ARE DETECTED BY THE DRIVER AND THE INDIVIDUAL    CD 121
C    SUBROUTINES.                                                         CD 122
C                                                                         CD 123
C NR    \ FLAG  - ERROR FLAG;  VALUES AND THEIR MEANINGS ARE --           CD 124
C       \             0     NO ERRORS DETECTED                            CD 125
C       \             N+K   NULL ROW IN A  --  ROW = K                    CD 126
C       \            2N+K   DUPLICATE ENTRY IN A  --  ROW = K             CD 127
C       \            3N+K   INSUFFICIENT STORAGE IN NSFC  --  ROW = K     CD 128
C       \            4N+1   INSUFFICIENT STORAGE IN NNFC                  CD 129
C       \            5N+K   NULL PIVOT  --  ROW = K                       CD 130
C       \            6N+K   INSUFFICIENT STORAGE IN NSFC  --  ROW = K     CD 131
C       \            7N+1   INSUFFICIENT STORAGE IN NNFC                  CD 132
C       \            8N+K   ZERO PIVOT  --  ROW = K                       CD 133
C       \           10N+1   INSUFFICIENT STORAGE IN CDRV                  CD 134
C       \           11N+1   ILLEGAL PATH SPECIFICATION                    CD 135
C                                                                         CD 136
C         WORKING STORAGE IS NEEDED FOR THE FACTORED FORM OF THE MATRIX   CD 137
C    M PLUS VARIOUS TEMPORARY VECTORS.  THE ARRAYS ISP AND RSP SHOULD BE  CD 138
C    EQUIVALENCED;  INTEGER STORAGE IS ALLOCATED FROM THE BEGINNING OF    CD 139
C    ISP AND REAL STORAGE FROM THE END OF RSP.                            CD 140
C                                                                         CD 141
C NV    \ NSP   - DECLARED DIMENSION OF RSP;  NSP GENERALLY MUST          CD 142
C       \           BE LARGER THAN  8N+2 + 2K  (WHERE  K = (NUMBER OF     CD 143
C       \           NONZERO ENTRIES IN M)).                               CD 144
C NVIRA \ ISP   - INTEGER WORKING STORAGE DIVIDED UP INTO VARIOUS ARRAYS  CD 145
C       \           NEEDED BY THE SUBROUTINES;  ISP AND RSP SHOULD BE     CD 146
C       \           EQUIVALENCED.                                         CD 147
C       \           SIZE = LRATIO*NSP.                                    CD 148
C FVIRA \ RSP   - REAL WORKING STORAGE DIVIDED UP INTO VARIOUS ARRAYS     CD 149
C       \           NEEDED BY THE SUBROUTINES;  ISP AND RSP SHOULD BE     CD 150
C       \           EQUIVALENCED.                                         CD 151
C       \           SIZE = NSP.                                           CD 152
C NR    \ ESP   - IF SUFFICIENT STORAGE WAS AVAILABLE TO PERFORM THE      CD 153
C       \           SYMBOLIC FACTORIZATION (NSFC), THEN ESP IS SET TO     CD 154
C       \           THE AMOUNT OF EXCESS STORAGE PROVIDED (NEGATIVE IF    CD 155
C       \           INSUFFICIENT STORAGE WAS AVAILABLE TO PERFORM THE     CD 156
C       \           NUMERIC FACTORIZATION (NNFC)).                        CD 157
C                                                                         CD 158
C                                                                         CD 159
C  CONVERSION TO DOUBLE PRECISION                                         CD 160
C                                                                         CD 161
C    TO CONVERT THESE ROUTINES FOR DOUBLE PRECISION ARRAYS, SIMPLY USE    CD 162
C    THE DOUBLE PRECISION DECLARATIONS IN PLACE OF THE REAL DECLARATIONS  CD 163
C    IN EACH SUBPROGRAM;  IN ADDITION, THE DATA VALUE OF THE INTEGER      CD 164
C    VARIABLE LRATIO MUST BE SET AS INDICATED IN SUBROUTINE CDRV          CD 165
C                                                                         CD 166
        INTEGER  R(1), C(1), IC(1),  IA(1), JA(1),  ISP(1), ESP,  PATH,   CD 167
     *     FLAG,  D, U, Q, ROW, TMP, AR,  UMAX                            CD 168
C       REAL  A(1), B(1), Z(1), RSP(1)                                    CD 169
        DOUBLE PRECISION  A(1), B(1), Z(1), RSP(1)                        CD 170
C                                                                         CD 171
C  SET LRATIO EQUAL TO THE RATIO BETWEEN THE LENGTH OF FLOATING POINT     CD 172
C  AND INTEGER ARRAY DATA;  E. G., LRATIO = 1 FOR (REAL, INTEGER),        CD 173
C  LRATIO = 2 FOR (DOUBLE PRECISION, INTEGER)                             CD 174
C                                                                         CD 175
        DATA LRATIO/1/                                                    CD 176
C                                                                         CD 177
        IF (PATH.LT.1 .OR. 5.LT.PATH)  GO TO 111                          CD 178
C******  INITIALIZE AND DIVIDE UP TEMPORARY STORAGE  *******************  CD 179
        IL   = 1                                                          CD 180
        IJL  = IL  + (N+1)                                                CD 181
        IU   = IJL +   N                                                  CD 182
        IJU  = IU  + (N+1)                                                CD 183
        IRL  = IJU +   N                                                  CD 184
        JRL  = IRL +   N                                                  CD 185
        JL   = JRL +   N                                                  CD 186
C                                                                         CD 187
C  ******  REORDER A IF NECESSARY, CALL NSFC IF FLAG IS SET  ***********  CD 188
        IF ((PATH-1) * (PATH-5) .NE. 0)  GO TO 5                          CD 189
          MAX = (LRATIO*NSP + 1 - JL) - (N+1) - 5*N                       CD 190
          JLMAX = MAX/2                                                   CD 191
          Q     = JL   + JLMAX                                            CD 192
          IRA   = Q    + (N+1)                                            CD 193
          JRA   = IRA  +   N                                              CD 194
          IRAC  = JRA  +   N                                              CD 195
          IRU   = IRAC +   N                                              CD 196
          JRU   = IRU  +   N                                              CD 197
          JUTMP = JRU  +   N                                              CD 198
          JUMAX = LRATIO*NSP  + 1 - JUTMP                                 CD 199
          ESP = MAX/LRATIO                                                CD 200
          IF (JLMAX.LE.0 .OR. JUMAX.LE.0)  GO TO 110                      CD 201
C                                                                         CD 202
          DO 1 I=1,N                                                      CD 203
            IF (C(I).NE.I)  GO TO 2                                       CD 204
   1        CONTINUE                                                      CD 205
          GO TO 3                                                         CD 206
   2      AR = NSP + 1 - N                                                CD 207
          CALL  NROC                                                      CD 208
     *       (N, IC, IA,JA,A, ISP(IL), RSP(AR), ISP(IU), FLAG)            CD 209
          IF (FLAG.NE.0)  GO TO 100                                       CD 210
C                                                                         CD 211
   3      CALL  NSFC                                                      CD 212
     *       (N, R, IC, IA,JA,                                            CD 213
     *        JLMAX, ISP(IL), ISP(JL), ISP(IJL),                          CD 214
     *        JUMAX, ISP(IU), ISP(JUTMP), ISP(IJU),                       CD 215
     *        ISP(Q), ISP(IRA), ISP(JRA), ISP(IRAC),                      CD 216
     *        ISP(IRL), ISP(JRL), ISP(IRU), ISP(JRU),  FLAG)              CD 217
          IF(FLAG .NE. 0)  GO TO 100                                      CD 218
C  ******  MOVE JU NEXT TO JL  *****************************************  CD 219
          JLMAX = ISP(IJL+N-1)                                            CD 220
          JU    = JL + JLMAX                                              CD 221
          JUMAX = ISP(IJU+N-1)                                            CD 222
          IF (JUMAX.LE.0)  GO TO 5                                        CD 223
          DO 4 J=1,JUMAX                                                  CD 224
   4        ISP(JU+J-1) = ISP(JUTMP+J-1)                                  CD 225
C                                                                         CD 226
C  ******  CALL REMAINING SUBROUTINES  *********************************  CD 227
   5    JLMAX = ISP(IJL+N-1)                                              CD 228
        JU    = JL  + JLMAX                                               CD 229
        JUMAX = ISP(IJU+N-1)                                              CD 230
        L     = (JU + JUMAX - 2 + LRATIO)  /  LRATIO    +    1            CD 231
        LMAX  = ISP(IL+N) - 1                                             CD 232
        D     = L   + LMAX                                                CD 233
        U     = D   + N                                                   CD 234
        ROW   = NSP + 1 - N                                               CD 235
        TMP   = ROW - N                                                   CD 236
        UMAX  = TMP - U                                                   CD 237
        ESP   = UMAX - (ISP(IU+N) - 1)                                    CD 238
C                                                                         CD 239
        IF ((PATH-1) * (PATH-2) .NE. 0)  GO TO 6                          CD 240
          IF (UMAX.LE.0)  GO TO 110                                       CD 241
          CALL NNFC                                                       CD 242
     *       (N,  R, C, IC,  IA, JA, A, Z, B,                             CD 243
     *        LMAX, ISP(IL), ISP(JL), ISP(IJL), RSP(L),  RSP(D),          CD 244
     *        UMAX, ISP(IU), ISP(JU), ISP(IJU), RSP(U),                   CD 245
     *        RSP(ROW), RSP(TMP),  ISP(IRL), ISP(JRL),  FLAG)             CD 246
          IF(FLAG .NE. 0)  GO TO 100                                      CD 247
C                                                                         CD 248
   6    IF ((PATH-3) .NE. 0)  GO TO 7                                     CD 249
          CALL NNSC                                                       CD 250
     *       (N,  R, C,  ISP(IL), ISP(JL), ISP(IJL), RSP(L),              CD 251
     *        RSP(D),    ISP(IU), ISP(JU), ISP(IJU), RSP(U),              CD 252
     *        Z, B,  RSP(TMP))                                            CD 253
C                                                                         CD 254
   7    IF ((PATH-4) .NE. 0)  GO TO 8                                     CD 255
          CALL NNTC                                                       CD 256
     *       (N,  R, C,  ISP(IL), ISP(JL), ISP(IJL), RSP(L),              CD 257
     *        RSP(D),    ISP(IU), ISP(JU), ISP(IJU), RSP(U),              CD 258
     *        Z, B,  RSP(TMP))                                            CD 259
   8    RETURN                                                            CD 260
C                                                                         CD 261
C ** ERROR:  ERROR DETECTED IN NROC, NSFC, NNFC, OR NNSC                  CD 262
 100    RETURN                                                            CD 263
C ** ERROR:  INSUFFICIENT STORAGE                                         CD 264
 110    FLAG = 10*N + 1                                                   CD 265
        RETURN                                                            CD 266
C ** ERROR:  ILLEGAL PATH SPECIFICATION                                   CD 267
 111    FLAG = 11*N + 1                                                   CD 268
        RETURN                                                            CD 269
        END                                                               CD 270

        SUBROUTINE NNSC
     *     (N, R, C, IL, JL, IJL, L, D, IU, JU, IJU, U, Z, B, TMP)        CD1000
C                                                                         CD1001
C       INPUT VARIABLES:   N, R, C, IL, JL, IJL, L, D, IU, JU, IJU, U, B  CD1002
C       OUTPUT VARIABLES:  Z                                              CD1003
C                                                                         CD1004
C       PARAMETERS USED INTERNALLY:                                       CD1005
C FIA   \ TMP   - TEMPORARY VECTOR WHICH GETS RESULT OF SOLVING  LY = B.  CD1006
C       \           SIZE = N.                                             CD1007
C                                                                         CD1008
C  INTERNAL VARIABLES:                                                    CD1009
C    JMIN, JMAX - INDICES OF THE FIRST AND LAST POSITIONS IN A ROW OF     CD1010
C      U OR L  TO BE USED.                                                CD1011
C                                                                         CD1012
        INTEGER R(1), C(1), IL(1), JL(1), IJL(1), IU(1), JU(1), IJU(1)    CD1013
C       REAL L(1), D(1), U(1), B(1), Z(1), TMP(1), TMPK, SUM              CD1014
        DOUBLE PRECISION  L(1), D(1), U(1), B(1), Z(1), TMP(1), TMPK,SUM  CD1015
C                                                                         CD1016
C  ******  SET TMP TO REORDERED B  *************************************  CD1017
        DO 1 K=1,N                                                        CD1018
   1      TMP(K) = B(R(K))                                                CD1019
C  ******  SOLVE  LY = B  BY FORWARD SUBSTITUTION  *********************  CD1020
        DO 3 K=1,N                                                        CD1021
          JMIN = IL(K)                                                    CD1022
          JMAX = IL(K+1) - 1                                              CD1023
          TMPK = -D(K) * TMP(K)                                           CD1024
          TMP(K) = -TMPK                                                  CD1025
          IF (JMIN .GT. JMAX) GO TO 3                                     CD1026
          ML = IJL(K) - JMIN                                              CD1027
          DO 2 J=JMIN,JMAX                                                CD1028
   2        TMP(JL(ML+J)) = TMP(JL(ML+J)) + TMPK * L(J)                   CD1029
   3      CONTINUE                                                        CD1030
C  ******  SOLVE  UX = Y  BY BACK SUBSTITUTION  ************************  CD1031
        K = N                                                             CD1032
        DO 6 I=1,N                                                        CD1033
          SUM = -TMP(K)                                                   CD1034
          JMIN = IU(K)                                                    CD1035
          JMAX = IU(K+1) - 1                                              CD1036
          IF (JMIN .GT. JMAX) GO TO 5                                     CD1037
          MU = IJU(K) - JMIN                                              CD1038
          DO 4 J=JMIN,JMAX                                                CD1039
   4        SUM = SUM + U(J) * TMP(JU(MU+J))                              CD1040
   5      TMP(K) = -SUM                                                   CD1041
          Z(C(K)) = -SUM                                                  CD1042
          K = K - 1                                                       CD1043
   6      CONTINUE                                                        CD1044
        RETURN                                                            CD1045
        END                                                               CD1046

        SUBROUTINE  NSFC
     *      (N, R, IC, IA,JA, JLMAX,IL,JL,IJL, JUMAX,IU,JU,IJU,           CD 513
     *       Q, IRA,JRA, IRAC, IRL,JRL, IRU,JRU, FLAG)                    CD 514
C                                                                         CD 515
C       INPUT VARIABLES:  N, R, IC, IA, JA, JLMAX, JUMAX.                 CD 516
C       OUTPUT VARIABLES: IL, JL, IJL, IU, JU, IJU, FLAG.                 CD 517
C                                                                         CD 518
C       PARAMETERS USED INTERNALLY:                                       CD 519
C NIA   \ Q     - SUPPOSE  M'  IS THE RESULT OF REORDERING  M.  IF        CD 520
C       \           PROCESSING OF THE ITH ROW OF  M'  (HENCE THE ITH      CD 521
C       \           ROW OF  U) IS BEING DONE,  Q(J)  IS INITIALLY         CD 522
C       \           NONZERO IF  M'(I,J) IS NONZERO (J.GE.I).  SINCE       CD 523
C       \           VALUES NEED NOT BE STORED, EACH ENTRY POINTS TO THE   CD 524
C       \           NEXT NONZERO AND  Q(N+1)  POINTS TO THE FIRST.  N+1   CD 525
C       \           INDICATES THE END OF THE LIST.  FOR EXAMPLE, IF N=9   CD 526
C       \           AND THE 5TH ROW OF  M'  IS                            CD 527
C       \              0 X X 0 X 0 0 X 0                                  CD 528
C       \           THEN  Q  WILL INITIALLY BE                            CD 529
C       \              A A A A 8 A A 10 5           (A - ARBITRARY).      CD 530
C       \           AS THE ALGORITHM PROCEEDS, OTHER ELEMENTS OF  Q       CD 531
C       \           ARE INSERTED IN THE LIST BECAUSE OF FILLIN.           CD 532
C       \           Q  IS USED IN AN ANALOGOUS MANNER TO COMPUTE THE      CD 533
C       \           ITH COLUMN OF  L.                                     CD 534
C       \           SIZE = N+1.                                           CD 535
C NIA   \ IRA,  - VECTORS USED TO FIND THE COLUMNS OF  M.  AT THE KTH     CD 536
C NIA   \ JRA,      STEP OF THE FACTORIZATION,  IRAC(K)  POINTS TO THE    CD 537
C NIA   \ IRAC      HEAD OF A LINKED LIST IN  JRA  OF ROW INDICES I       CD 538
C       \           SUCH THAT I .GE. K AND  M(I,K)  IS NONZERO.  ZERO     CD 539
C       \           INDICATES THE END OF THE LIST.  IRA(I)  (I.GE.K)      CD 540
C       \           POINTS TO THE SMALLEST J SUCH THAT J .GE. K AND       CD 541
C       \           M(I,J)  IS NONZERO.                                   CD 542
C       \           SIZE OF EACH = N.                                     CD 543
C NIA   \ IRL,  - VECTORS USED TO FIND THE ROWS OF  L.  AT THE KTH STEP   CD 544
C NIA   \ JRL       OF THE FACTORIZATION,  JRL(K)  POINTS TO THE HEAD     CD 545
C       \           OF A LINKED LIST IN  JRL  OF COLUMN INDICES J         CD 546
C       \           SUCH J .LT. K AND  L(K,J)  IS NONZERO.  ZERO          CD 547
C       \           INDICATES THE END OF THE LIST.  IRL(J)  (J.LT.K)      CD 548
C       \           POINTS TO THE SMALLEST I SUCH THAT I .GE. K AND       CD 549
C       \           L(I,J)  IS NONZERO.                                   CD 550
C       \           SIZE OF EACH = N.                                     CD 551
C NIA   \ IRU,  - VECTORS USED IN A MANNER ANALOGOUS TO  IRL AND JRL      CD 552
C NIA   \ JRU       TO FIND THE COLUMNS OF  U.                            CD 553
C       \           SIZE OF EACH = N.                                     CD 554
C                                                                         CD 555
C  INTERNAL VARIABLES:                                                    CD 556
C    JLPTR - POINTS TO THE LAST POSITION USED IN  JL.                     CD 557
C    JUPTR - POINTS TO THE LAST POSITION USED IN  JU.                     CD 558
C    JMIN,JMAX - ARE THE INDICES IN  A OR U  OF THE FIRST AND LAST        CD 559
C                ELEMENTS TO BE EXAMINED IN A GIVEN ROW.                  CD 560
C                FOR EXAMPLE,  JMIN=IA(K), JMAX=IA(K+1)-1.                CD 561
C                                                                         CD 562
        INTEGER CEND, QM, REND, RK, VJ                                    CD 563
        INTEGER IA(1), JA(1), IRA(1), JRA(1), IL(1), JL(1), IJL(1)        CD 564
        INTEGER IU(1), JU(1), IJU(1), IRL(1), JRL(1), IRU(1), JRU(1)      CD 565
        INTEGER R(1), IC(1), Q(1), IRAC(1), FLAG                          CD 566
C                                                                         CD 567
C  ******  INITIALIZE POINTERS  ****************************************  CD 568
        NP1 = N + 1                                                       CD 569
        JLMIN = 1                                                         CD 570
        JLPTR = 0                                                         CD 571
        IL(1) = 1                                                         CD 572
        JUMIN = 1                                                         CD 573
        JUPTR = 0                                                         CD 574
        IU(1) = 1                                                         CD 575
        DO 1 K=1,N                                                        CD 576
          IRAC(K) = 0                                                     CD 577
          JRA(K) = 0                                                      CD 578
          JRL(K) = 0                                                      CD 579
   1      JRU(K) = 0                                                      CD 580
C  ******  INITIALIZE COLUMN POINTERS FOR A  ***************************  CD 581
        DO 2 K=1,N                                                        CD 582
          RK = R(K)                                                       CD 583
          IAK = IA(RK)                                                    CD 584
          IF (IAK .GE. IA(RK+1))  GO TO 101                               CD 585
          JAIAK = IC(JA(IAK))                                             CD 586
          IF (JAIAK .GT. K)  GO TO 105                                    CD 587
          JRA(K) = IRAC(JAIAK)                                            CD 588
          IRAC(JAIAK) = K                                                 CD 589
   2      IRA(K) = IAK                                                    CD 590
C                                                                         CD 591
C  ******  FOR EACH COLUMN OF L AND ROW OF U  **************************  CD 592
        DO 41 K=1,N                                                       CD 593
C                                                                         CD 594
C  ******  INITIALIZE Q FOR COMPUTING KTH COLUMN OF L  *****************  CD 595
          Q(NP1) = NP1                                                    CD 596
          LUK = -1                                                        CD 597
C  ******  BY FILLING IN KTH COLUMN OF A  ******************************  CD 598
          VJ = IRAC(K)                                                    CD 599
          IF (VJ .EQ. 0)  GO TO 5                                         CD 600
   3        QM = NP1                                                      CD 601
   4        M = QM                                                        CD 602
            QM =  Q(M)                                                    CD 603
            IF (QM .LT. VJ)  GO TO 4                                      CD 604
            IF (QM .EQ. VJ)  GO TO 102                                    CD 605
              LUK = LUK + 1                                               CD 606
              Q(M) = VJ                                                   CD 607
              Q(VJ) = QM                                                  CD 608
              VJ = JRA(VJ)                                                CD 609
              IF (VJ .NE. 0)  GO TO 3                                     CD 610
C  ******  LINK THROUGH JRU  *******************************************  CD 611
   5      LASTID = 0                                                      CD 612
          LASTI = 0                                                       CD 613
          IJL(K) = JLPTR                                                  CD 614
          I = K                                                           CD 615
   6        I = JRU(I)                                                    CD 616
            IF (I .EQ. 0)  GO TO 10                                       CD 617
            QM = NP1                                                      CD 618
            JMIN = IRL(I)                                                 CD 619
            JMAX = IJL(I) + IL(I+1) - IL(I) - 1                           CD 620
            LONG = JMAX - JMIN                                            CD 621
            IF (LONG .LT. 0)  GO TO 6                                     CD 622
            JTMP = JL(JMIN)                                               CD 623
            IF (JTMP .NE. K)  LONG = LONG + 1                             CD 624
            IF (JTMP .EQ. K)  R(I) = -R(I)                                CD 625
            IF (LASTID .GE. LONG)  GO TO 7                                CD 626
              LASTI = I                                                   CD 627
              LASTID = LONG                                               CD 628
C  ******  AND MERGE THE CORRESPONDING COLUMNS INTO THE KTH COLUMN  ****  CD 629
   7        DO 9 J=JMIN,JMAX                                              CD 630
              VJ = JL(J)                                                  CD 631
   8          M = QM                                                      CD 632
              QM = Q(M)                                                   CD 633
              IF (QM .LT. VJ)  GO TO 8                                    CD 634
              IF (QM .EQ. VJ)  GO TO 9                                    CD 635
                LUK = LUK + 1                                             CD 636
                Q(M) = VJ                                                 CD 637
                Q(VJ) = QM                                                CD 638
                QM = VJ                                                   CD 639
   9          CONTINUE                                                    CD 640
              GO TO 6                                                     CD 641
C  ******  LASTI IS THE LONGEST COLUMN MERGED INTO THE KTH  ************  CD 642
C  ******  SEE IF IT EQUALS THE ENTIRE KTH COLUMN  *********************  CD 643
  10      QM = Q(NP1)                                                     CD 644
          IF (QM .NE. K)  GO TO 105                                       CD 645
          IF (LUK .EQ. 0)  GO TO 17                                       CD 646
          IF (LASTID .NE. LUK)  GO TO 11                                  CD 647
C  ******  IF SO, JL CAN BE COMPRESSED  ********************************  CD 648
          IRLL = IRL(LASTI)                                               CD 649
          IJL(K) = IRLL + 1                                               CD 650
          IF (JL(IRLL) .NE. K)  IJL(K) = IJL(K) - 1                       CD 651
          GO TO 17                                                        CD 652
C  ******  IF NOT, SEE IF KTH COLUMN CAN OVERLAP THE PREVIOUS ONE  *****  CD 653
  11      IF (JLMIN .GT. JLPTR)  GO TO 15                                 CD 654
          QM = Q(QM)                                                      CD 655
          DO 12 J=JLMIN,JLPTR                                             CD 656
            IF (JL(J) - QM)  12, 13, 15                                   CD 657
  12        CONTINUE                                                      CD 658
          GO TO 15                                                        CD 659
  13      IJL(K) = J                                                      CD 660
          DO 14 I=J,JLPTR                                                 CD 661
            IF (JL(I) .NE. QM)  GO TO 15                                  CD 662
            QM = Q(QM)                                                    CD 663
            IF (QM .GT. N)  GO TO 17                                      CD 664
  14        CONTINUE                                                      CD 665
          JLPTR = J - 1                                                   CD 666
C  ******  MOVE COLUMN INDICES FROM Q TO JL, UPDATE VECTORS  ***********  CD 667
  15      JLMIN = JLPTR + 1                                               CD 668
          IJL(K) = JLMIN                                                  CD 669
          IF (LUK .EQ. 0)  GO TO 17                                       CD 670
          JLPTR = JLPTR + LUK                                             CD 671
          IF (JLPTR .GT. JLMAX)  GO TO 103                                CD 672
            QM = Q(NP1)                                                   CD 673
            DO 16 J=JLMIN,JLPTR                                           CD 674
              QM = Q(QM)                                                  CD 675
  16          JL(J) = QM                                                  CD 676
  17      IRL(K) = IJL(K)                                                 CD 677
          IL(K+1) = IL(K) + LUK                                           CD 678
C                                                                         CD 679
C  ******  INITIALIZE Q FOR COMPUTING KTH ROW OF U  ********************  CD 680
          Q(NP1) = NP1                                                    CD 681
          LUK = -1                                                        CD 682
C  ******  BY FILLING IN KTH ROW OF REORDERED A  ***********************  CD 683
          RK = R(K)                                                       CD 684
          JMIN = IRA(K)                                                   CD 685
          JMAX = IA(RK+1) - 1                                             CD 686
          IF (JMIN .GT. JMAX)  GO TO 20                                   CD 687
          DO 19 J=JMIN,JMAX                                               CD 688
            VJ = IC(JA(J))                                                CD 689
            QM = NP1                                                      CD 690
  18        M = QM                                                        CD 691
            QM = Q(M)                                                     CD 692
            IF (QM .LT. VJ)  GO TO 18                                     CD 693
            IF (QM .EQ. VJ)  GO TO 102                                    CD 694
              LUK = LUK + 1                                               CD 695
              Q(M) = VJ                                                   CD 696
              Q(VJ) = QM                                                  CD 697
  19        CONTINUE                                                      CD 698
C  ******  LINK THROUGH JRL,  ******************************************  CD 699
  20      LASTID = 0                                                      CD 700
          LASTI = 0                                                       CD 701
          IJU(K) = JUPTR                                                  CD 702
          I = K                                                           CD 703
          I1 = JRL(K)                                                     CD 704
  21        I = I1                                                        CD 705
            IF (I .EQ. 0)  GO TO 26                                       CD 706
            I1 = JRL(I)                                                   CD 707
            QM = NP1                                                      CD 708
            JMIN = IRU(I)                                                 CD 709
            JMAX = IJU(I) + IU(I+1) - IU(I) - 1                           CD 710
            LONG = JMAX - JMIN                                            CD 711
            IF (LONG .LT. 0)  GO TO 21                                    CD 712
            JTMP = JU(JMIN)                                               CD 713
            IF (JTMP .EQ. K)  GO TO 22                                    CD 714
C  ******  UPDATE IRL AND JRL, *****************************************  CD 715
              LONG = LONG + 1                                             CD 716
              CEND = IJL(I) + IL(I+1) - IL(I)                             CD 717
              IRL(I) = IRL(I) + 1                                         CD 718
              IF (IRL(I) .GE. CEND)  GO TO 22                             CD 719
                J = JL(IRL(I))                                            CD 720
                JRL(I) = JRL(J)                                           CD 721
                JRL(J) = I                                                CD 722
  22        IF (LASTID .GE. LONG)  GO TO 23                               CD 723
              LASTI = I                                                   CD 724
              LASTID = LONG                                               CD 725
C  ******  AND MERGE THE CORRESPONDING ROWS INTO THE KTH ROW  **********  CD 726
  23        DO 25 J=JMIN,JMAX                                             CD 727
              VJ = JU(J)                                                  CD 728
  24          M = QM                                                      CD 729
              QM = Q(M)                                                   CD 730
              IF (QM .LT. VJ)  GO TO 24                                   CD 731
              IF (QM .EQ. VJ)  GO TO 25                                   CD 732
                LUK = LUK + 1                                             CD 733
                Q(M) = VJ                                                 CD 734
                Q(VJ) = QM                                                CD 735
                QM = VJ                                                   CD 736
  25          CONTINUE                                                    CD 737
            GO TO 21                                                      CD 738
C  ******  UPDATE JRL(K) AND IRL(K)  ***********************************  CD 739
  26      IF (IL(K+1) .LE. IL(K))  GO TO 27                               CD 740
            J = JL(IRL(K))                                                CD 741
            JRL(K) = JRL(J)                                               CD 742
            JRL(J) = K                                                    CD 743
C  ******  LASTI IS THE LONGEST ROW MERGED INTO THE KTH  ***************  CD 744
C  ******  SEE IF IT EQUALS THE ENTIRE KTH ROW  ************************  CD 745
  27      QM = Q(NP1)                                                     CD 746
          IF (QM .NE. K)  GO TO 105                                       CD 747
          IF (LUK .EQ. 0)  GO TO 34                                       CD 748
          IF (LASTID .NE. LUK)  GO TO 28                                  CD 749
C  ******  IF SO, JU CAN BE COMPRESSED  ********************************  CD 750
          IRUL = IRU(LASTI)                                               CD 751
          IJU(K) = IRUL + 1                                               CD 752
          IF (JU(IRUL) .NE. K)  IJU(K) = IJU(K) - 1                       CD 753
          GO TO 34                                                        CD 754
C  ******  IF NOT, SEE IF KTH ROW CAN OVERLAP THE PREVIOUS ONE  ********  CD 755
  28      IF (JUMIN .GT. JUPTR)  GO TO 32                                 CD 756
          QM = Q(QM)                                                      CD 757
          DO 29 J=JUMIN,JUPTR                                             CD 758
            IF (JU(J) - QM)  29, 30, 32                                   CD 759
  29        CONTINUE                                                      CD 760
          GO TO 32                                                        CD 761
  30      IJU(K) = J                                                      CD 762
          DO 31 I=J,JUPTR                                                 CD 763
            IF (JU(I) .NE. QM)  GO TO 32                                  CD 764
            QM = Q(QM)                                                    CD 765
            IF (QM .GT. N)  GO TO 34                                      CD 766
  31        CONTINUE                                                      CD 767
          JUPTR = J - 1                                                   CD 768
C  ******  MOVE ROW INDICES FROM Q TO JU, UPDATE VECTORS  **************  CD 769
  32      JUMIN = JUPTR + 1                                               CD 770
          IJU(K) = JUMIN                                                  CD 771
          IF (LUK .EQ. 0)  GO TO 34                                       CD 772
          JUPTR = JUPTR + LUK                                             CD 773
          IF (JUPTR .GT. JUMAX)  GO TO 106                                CD 774
            QM = Q(NP1)                                                   CD 775
            DO 33 J=JUMIN,JUPTR                                           CD 776
              QM = Q(QM)                                                  CD 777
  33          JU(J) = QM                                                  CD 778
  34      IRU(K) = IJU(K)                                                 CD 779
          IU(K+1) = IU(K) + LUK                                           CD 780
C                                                                         CD 781
C  ******  UPDATE IRU, JRU  ********************************************  CD 782
          I = K                                                           CD 783
  35        I1 = JRU(I)                                                   CD 784
            IF (R(I) .LT. 0)  GO TO 36                                    CD 785
            REND = IJU(I) + IU(I+1) - IU(I)                               CD 786
            IF (IRU(I) .GE. REND)  GO TO 37                               CD 787
              J = JU(IRU(I))                                              CD 788
              JRU(I) = JRU(J)                                             CD 789
              JRU(J) = I                                                  CD 790
              GO TO 37                                                    CD 791
  36        R(I) = -R(I)                                                  CD 792
  37        I = I1                                                        CD 793
            IF (I .EQ. 0)  GO TO 38                                       CD 794
            IRU(I) = IRU(I) + 1                                           CD 795
            GO TO 35                                                      CD 796
C                                                                         CD 797
C  ******  UPDATE IRA, JRA, IRAC  **************************************  CD 798
  38      I = IRAC(K)                                                     CD 799
          IF (I .EQ. 0)  GO TO 41                                         CD 800
  39        I1 = JRA(I)                                                   CD 801
            IRA(I) = IRA(I) + 1                                           CD 802
            IF (IRA(I) .GE. IA(R(I)+1))  GO TO 40                         CD 803
            IRAI = IRA(I)                                                 CD 804
            JAIRAI = IC(JA(IRAI))                                         CD 805
            IF (JAIRAI .GT. I)  GO TO 40                                  CD 806
            JRA(I) = IRAC(JAIRAI)                                         CD 807
            IRAC(JAIRAI) = I                                              CD 808
  40        I = I1                                                        CD 809
            IF (I .NE. 0)  GO TO 39                                       CD 810
  41      CONTINUE                                                        CD 811
C                                                                         CD 812
        IJL(N) = JLPTR                                                    CD 813
        IJU(N) = JUPTR                                                    CD 814
        FLAG = 0                                                          CD 815
        RETURN                                                            CD 816
C                                                                         CD 817
C ** ERROR:  NULL ROW IN A                                                CD 818
 101    FLAG = N + RK                                                     CD 819
        RETURN                                                            CD 820
C ** ERROR:  DUPLICATE ENTRY IN A                                         CD 821
 102    FLAG = 2*N + RK                                                   CD 822
        RETURN                                                            CD 823
C ** ERROR:  INSUFFICIENT STORAGE FOR JL                                  CD 824
 103    FLAG = 3*N + K                                                    CD 825
        RETURN                                                            CD 826
C ** ERROR:  NULL PIVOT                                                   CD 827
 105    FLAG = 5*N + K                                                    CD 828
        RETURN                                                            CD 829
C ** ERROR:  INSUFFICIENT STORAGE FOR JU                                  CD 830
 106    FLAG = 6*N + K                                                    CD 831
        RETURN                                                            CD 832
        END                                                               CD 833

        SUBROUTINE  SSF
     *     (N, P,IP, IA,JA, IJU,JU,IU,JUMAX, Q, MARK, JL, FLAG)           SD 315
C                                                                         SD 316
C  ADDITIONAL PARAMETERS                                                  SD 317
C                                                                         SD 318
C    Q     - INTEGER ONE-DIMENSIONAL WORK ARRAY;  DIMENSION = N           SD 319
C                                                                         SD 320
C    MARK  - INTEGER ONE-DIMENSIONAL WORK ARRAY;  DIMENSION = N           SD 321
C                                                                         SD 322
C    JL    - INTEGER ONE-DIMENSIONAL WORK ARRAY;  DIMENSION = N           SD 323
C                                                                         SD 324
C                                                                         SD 325
C  DEFINITIONS OF INTERNAL PARAMETERS (DURING K-TH STAGE OF ELIMINATION)  SD 326
C                                                                         SD 327
C    Q CONTAINS AN ORDERED LINKED LIST REPRESENTATION OF THE NONZERO      SD 328
C      STRUCTURE OF THE K-TH ROW OF U --                                  SD 329
C        Q(K) IS THE FIRST COLUMN WITH A NONZERO ENTRY                    SD 330
C        Q(I) IS THE NEXT COLUMN WITH A NONZERO ENTRY AFTER COLUMN I      SD 331
C      IN EITHER CASE, Q(I) = N+1 INDICATES THE END OF THE LIST           SD 332
C                                                                         SD 333
C    JL CONTAINS LISTS OF ROWS TO BE MERGED INTO UNELIMINATED ROWS --     SD 334
C        I GE K => JL(I) IS THE FIRST ROW TO BE MERGED INTO ROW I         SD 335
C        I LT K => JL(I) IS THE ROW FOLLOWING ROW I IN SOME LIST OF ROWS  SD 336
C      IN EITHER CASE, JL(I) = 0 INDICATES THE END OF A LIST              SD 337
C                                                                         SD 338
C    MARK(I) IS THE LAST ROW STORED IN JU FOR WHICH U(MARK(I),I) NE 0     SD 339
C                                                                         SD 340
C    JUMIN AND JUPTR ARE THE INDICES IN JU OF THE FIRST AND LAST          SD 341
C      ELEMENTS IN THE LAST ROW SAVED IN JU                               SD 342
C                                                                         SD 343
C    LUK IS THE NUMBER OF NONZERO ENTRIES IN THE K-TH ROW                 SD 344
C                                                                         SD 345
C-----------------------------------------------------------------------  SD 346
C                                                                         SD 347
        INTEGER  P(1), IP(1),  IA(1), JA(1),  IJU(1), JU(1), IU(1),       SD 348
     *     Q(1),  MARK(1),  JL(1),  FLAG,  TAG, VJ, QM                    SD 349
        LOGICAL  CLIQUE                                                   SD 350
C                                                                         SD 351
C----INITIALIZATION                                                       SD 352
        JUMIN = 1                                                         SD 353
        JUPTR = 0                                                         SD 354
        IU(1) = 1                                                         SD 355
        DO 1 K=1,N                                                        SD 356
          MARK(K) = 0                                                     SD 357
   1      JL(K) = 0                                                       SD 358
C                                                                         SD 359
C----FOR EACH ROW K                                                       SD 360
        DO 18 K=1,N                                                       SD 361
          LUK = 0                                                         SD 362
          Q(K) = N+1                                                      SD 363
C                                                                         SD 364
          TAG = MARK(K)                                                   SD 365
          CLIQUE = .FALSE.                                                SD 366
          IF (JL(K).NE.0)  CLIQUE = JL(JL(K)).EQ.0                        SD 367
C                                                                         SD 368
C------INITIALIZE NONZERO STRUCTURE OF K-TH ROW TO ROW P(K) OF M          SD 369
          JMIN = IA(P(K))                                                 SD 370
          JMAX = IA(P(K)+1) - 1                                           SD 371
          IF (JMIN.GT.JMAX)  GO TO 4                                      SD 372
          DO 3 J=JMIN,JMAX                                                SD 373
            VJ = IP(JA(J))                                                SD 374
            IF (VJ.LE.K)  GO TO 3                                         SD 375
C                                                                         SD 376
              QM = K                                                      SD 377
   2          M = QM                                                      SD 378
              QM = Q(M)                                                   SD 379
              IF (QM.LT.VJ)  GO TO 2                                      SD 380
              IF (QM.EQ.VJ)  GO TO 102                                    SD 381
                LUK = LUK+1                                               SD 382
                Q(M) = VJ                                                 SD 383
                Q(VJ) = QM                                                SD 384
                IF (MARK(VJ).NE.TAG)  CLIQUE = .FALSE.                    SD 385
C                                                                         SD 386
   3        CONTINUE                                                      SD 387
C                                                                         SD 388
C------IF EXACTLY ONE ROW IS TO BE MERGED INTO THE K-TH ROW AND THERE IS  SD 389
C------A NONZERO ENTRY IN EVERY COLUMN IN THAT ROW IN WHICH THERE IS A    SD 390
C------NONZERO ENTRY IN ROW P(K) OF M, THEN DO NOT COMPUTE FILL-IN, JUST  SD 391
C------USE THE COLUMN INDICES FOR THE ROW WHICH WAS TO HAVE BEEN MERGED   SD 392
   4      IF (.NOT.CLIQUE)  GO TO 5                                       SD 393
            IJU(K) = IJU(JL(K)) + 1                                       SD 394
            LUK = IU(JL(K)+1) - (IU(JL(K))+1)                             SD 395
            GO TO 17                                                      SD 396
C                                                                         SD 397
C------MODIFY NONZERO STRUCTURE OF K-TH ROW BY COMPUTING FILL-IN          SD 398
C------FOR EACH ROW I TO BE MERGED IN                                     SD 399
   5      LMAX = 0                                                        SD 400
          IJU(K) = JUPTR                                                  SD 401
C                                                                         SD 402
          I = K                                                           SD 403
   6      I = JL(I)                                                       SD 404
          IF (I.EQ.0)  GO TO 10                                           SD 405
C                                                                         SD 406
C--------MERGE ROW I INTO K-TH ROW                                        SD 407
            LUI = IU(I+1) - (IU(I)+1)                                     SD 408
            JMIN = IJU(I) +  1                                            SD 409
            JMAX = IJU(I) + LUI                                           SD 410
            QM = K                                                        SD 411
C                                                                         SD 412
            DO 8 J=JMIN,JMAX                                              SD 413
              VJ = JU(J)                                                  SD 414
   7          M = QM                                                      SD 415
              QM = Q(M)                                                   SD 416
              IF (QM.LT.VJ)  GO TO 7                                      SD 417
              IF (QM.EQ.VJ)  GO TO 8                                      SD 418
                LUK = LUK+1                                               SD 419
                Q(M) = VJ                                                 SD 420
                Q(VJ) = QM                                                SD 421
                QM = VJ                                                   SD 422
   8          CONTINUE                                                    SD 423
C                                                                         SD 424
C--------REMEMBER LENGTH AND POSITION IN JU OF LONGEST ROW MERGED         SD 425
            IF (LUI.LE.LMAX)  GO TO 9                                     SD 426
              LMAX = LUI                                                  SD 427
              IJU(K) = JMIN                                               SD 428
C                                                                         SD 429
   9        GO TO 6                                                       SD 430
C                                                                         SD 431
C------IF THE K-TH ROW IS THE SAME LENGTH AS THE LONGEST ROW MERGED,      SD 432
C------THEN USE THE COLUMN INDICES FOR THAT ROW                           SD 433
  10      IF (LUK.EQ.LMAX)  GO TO 17                                      SD 434
C                                                                         SD 435
C------IF THE TAIL OF THE LAST ROW SAVED IN JU IS THE SAME AS THE HEAD    SD 436
C------OF THE K-TH ROW, THEN OVERLAP THE TWO SETS OF COLUMN INDICES --    SD 437
C--------SEARCH LAST ROW SAVED FOR FIRST NONZERO ENTRY IN K-TH ROW ...    SD 438
            I = Q(K)                                                      SD 439
            IF (JUMIN.GT.JUPTR)  GO TO 12                                 SD 440
            DO 11 JMIN=JUMIN,JUPTR                                        SD 441
              IF (JU(JMIN)-I)  11, 13, 12                                 SD 442
  11          CONTINUE                                                    SD 443
  12        GO TO 15                                                      SD 444
C                                                                         SD 445
C--------... AND THEN TEST WHETHER TAIL MATCHES HEAD OF K-TH ROW          SD 446
  13        IJU(K) = JMIN                                                 SD 447
            DO 14 J=JMIN,JUPTR                                            SD 448
              IF (JU(J).NE.I)  GO TO 15                                   SD 449
              I = Q(I)                                                    SD 450
              IF (I.GT.N)  GO TO 17                                       SD 451
  14          CONTINUE                                                    SD 452
            JUPTR = JMIN - 1                                              SD 453
C                                                                         SD 454
C------SAVE NONZERO STRUCTURE OF K-TH ROW IN JU                           SD 455
  15      I = K                                                           SD 456
          JUMIN = JUPTR +  1                                              SD 457
          JUPTR = JUPTR + LUK                                             SD 458
          IF (JUPTR.GT.JUMAX)  GO TO 106                                  SD 459
          DO 16 J=JUMIN,JUPTR                                             SD 460
            I = Q(I)                                                      SD 461
            JU(J) = I                                                     SD 462
  16        MARK(I) = K                                                   SD 463
          IJU(K) = JUMIN                                                  SD 464
C                                                                         SD 465
C------ADD K TO ROW LIST FOR FIRST NONZERO ELEMENT IN K-TH ROW            SD 466
  17      IF (LUK.LE.1)  GO TO 18                                         SD 467
            I = JU(IJU(K))                                                SD 468
            JL(K) = JL(I)                                                 SD 469
            JL(I) = K                                                     SD 470
C                                                                         SD 471
  18      IU(K+1) = IU(K) + LUK                                           SD 472
C                                                                         SD 473
        FLAG = 0                                                          SD 474
        RETURN                                                            SD 475
C                                                                         SD 476
C ** ERROR -- DUPLICATE ENTRY IN A                                        SD 477
 102    FLAG = 2*N + P(K)                                                 SD 478
        RETURN                                                            SD 479
C ** ERROR -- INSUFFICIENT STORAGE FOR JU                                 SD 480
 106    FLAG = 6*N + K                                                    SD 481
        RETURN                                                            SD 482
        END                                                               SD 483

        SUBROUTINE  NNFC
     *     (N, R,C,IC, IA,JA,A, Z, B,                                     CD 843
     *      LMAX,IL,JL,IJL,L, D, UMAX,IU,JU,IJU,U,                        CD 844
     *      ROW, TMP, IRL,JRL, FLAG)                                      CD 845
C                                                                         CD 846
C       INPUT VARIABLES:   N, R, C, IC, IA, JA, A, B,                     CD 847
C                          IL, JL, IJL, LMAX, IU, JU, IJU, UMAX           CD 848
C       OUTPUT VARIABLES:  Z, L, D, U, FLAG                               CD 849
C                                                                         CD 850
C       PARAMETERS USED INTERNALLY:                                       CD 851
C NIA   \ IRL,  - VECTORS USED TO FIND THE ROWS OF  L.  AT THE KTH STEP   CD 852
C NIA   \ JRL       OF THE FACTORIZATION,  JRL(K)  POINTS TO THE HEAD     CD 853
C       \           OF A LINKED LIST IN  JRL  OF COLUMN INDICES J         CD 854
C       \           SUCH J .LT. K AND  L(K,J)  IS NONZERO.  ZERO          CD 855
C       \           INDICATES THE END OF THE LIST.  IRL(J)  (J.LT.K)      CD 856
C       \           POINTS TO THE SMALLEST I SUCH THAT I .GE. K AND       CD 857
C       \           L(I,J)  IS NONZERO.                                   CD 858
C       \           SIZE OF EACH = N.                                     CD 859
C FIA   \ ROW   - HOLDS INTERMEDIATE VALUES IN CALCULATION OF  U AND L.   CD 860
C       \           SIZE = N.                                             CD 861
C FIA   \ TMP   - HOLDS NEW RIGHT-HAND SIDE  B'  FOR SOLUTION OF THE      CD 862
C       \           EQUATION UX = B'.                                     CD 863
C       \           SIZE = N.                                             CD 864
C                                                                         CD 865
C  INTERNAL VARIABLES:                                                    CD 866
C    JMIN, JMAX - INDICES OF THE FIRST AND LAST POSITIONS IN A ROW TO     CD 867
C      BE EXAMINED.                                                       CD 868
C    SUM - USED IN CALCULATING  TMP.                                      CD 869
C                                                                         CD 870
        INTEGER RK,UMAX                                                   CD 871
        INTEGER  R(1), C(1), IC(1), IA(1), JA(1), IL(1), JL(1), IJL(1)    CD 872
        INTEGER  IU(1), JU(1), IJU(1), IRL(1), JRL(1), FLAG               CD 873
C       REAL  A(1), L(1), D(1), U(1), Z(1), B(1), ROW(1)                  CD 874
C       REAL TMP(1), LKI, SUM, DK                                         CD 875
        DOUBLE PRECISION  A(1), L(1), D(1), U(1), Z(1), B(1), ROW(1)      CD 876
        DOUBLE PRECISION  TMP(1), LKI, SUM, DK                            CD 877
C                                                                         CD 878
C  ******  INITIALIZE POINTERS AND TEST STORAGE  ***********************  CD 879
        IF(IL(N+1)-1 .GT. LMAX) GO TO 104                                 CD 880
        IF(IU(N+1)-1 .GT. UMAX) GO TO 107                                 CD 881
        DO 1 K=1,N                                                        CD 882
          IRL(K) = IL(K)                                                  CD 883
          JRL(K) = 0                                                      CD 884
   1      CONTINUE                                                        CD 885
C                                                                         CD 886
C  ******  FOR EACH ROW  ***********************************************  CD 887
        DO 19 K=1,N                                                       CD 888
C  ******  REVERSE JRL AND ZERO ROW WHERE KTH ROW OF L WILL FILL IN  ***  CD 889
          ROW(K) = 0                                                      CD 890
          I1 = 0                                                          CD 891
          IF (JRL(K) .EQ. 0) GO TO 3                                      CD 892
          I = JRL(K)                                                      CD 893
   2      I2 = JRL(I)                                                     CD 894
          JRL(I) = I1                                                     CD 895
          I1 = I                                                          CD 896
          ROW(I) = 0                                                      CD 897
          I = I2                                                          CD 898
          IF (I .NE. 0) GO TO 2                                           CD 899
C  ******  SET ROW TO ZERO WHERE U WILL FILL IN  ***********************  CD 900
   3      JMIN = IJU(K)                                                   CD 901
          JMAX = JMIN + IU(K+1) - IU(K) - 1                               CD 902
          IF (JMIN .GT. JMAX) GO TO 5                                     CD 903
          DO 4 J=JMIN,JMAX                                                CD 904
   4        ROW(JU(J)) = 0                                                CD 905
C  ******  PLACE KTH ROW OF A IN ROW  **********************************  CD 906
   5      RK = R(K)                                                       CD 907
          JMIN = IA(RK)                                                   CD 908
          JMAX = IA(RK+1) - 1                                             CD 909
          DO 6 J=JMIN,JMAX                                                CD 910
            ROW(IC(JA(J))) = A(J)                                         CD 911
   6        CONTINUE                                                      CD 912
C  ******  INITIALIZE SUM, AND LINK THROUGH JRL  ***********************  CD 913
          SUM = B(RK)                                                     CD 914
          I = I1                                                          CD 915
          IF (I .EQ. 0) GO TO 10                                          CD 916
C  ******  ASSIGN THE KTH ROW OF L AND ADJUST ROW, SUM  ****************  CD 917
   7        LKI = -ROW(I)                                                 CD 918
C  ******  IF L IS NOT REQUIRED, THEN COMMENT OUT THE FOLLOWING LINE  **  CD 919
            L(IRL(I)) = -LKI                                              CD 920
            SUM = SUM + LKI * TMP(I)                                      CD 921
            JMIN = IU(I)                                                  CD 922
            JMAX = IU(I+1) - 1                                            CD 923
            IF (JMIN .GT. JMAX) GO TO 9                                   CD 924
            MU = IJU(I) - JMIN                                            CD 925
            DO 8 J=JMIN,JMAX                                              CD 926
   8          ROW(JU(MU+J)) = ROW(JU(MU+J)) + LKI * U(J)                  CD 927
   9        I = JRL(I)                                                    CD 928
            IF (I .NE. 0) GO TO 7                                         CD 929
C                                                                         CD 930
C  ******  ASSIGN KTH ROW OF U AND DIAGONAL D, SET TMP(K)  *************  CD 931
  10      IF (ROW(K) .EQ. 0) GO TO 108                                    CD 932
          DK = 1 / ROW(K)                                                 CD 933
          D(K) = DK                                                       CD 934
          TMP(K) = SUM * DK                                               CD 935
          IF (K .EQ. N) GO TO 19                                          CD 936
          JMIN = IU(K)                                                    CD 937
          JMAX = IU(K+1) - 1                                              CD 938
          IF (JMIN .GT. JMAX)  GO TO 12                                   CD 939
          MU = IJU(K) - JMIN                                              CD 940
          DO 11 J=JMIN,JMAX                                               CD 941
  11        U(J) = ROW(JU(MU+J)) * DK                                     CD 942
  12      CONTINUE                                                        CD 943
C                                                                         CD 944
C  ******  UPDATE IRL AND JRL, KEEPING JRL IN DECREASING ORDER  ********  CD 945
  13      I = I1                                                          CD 946
          IF (I .EQ. 0) GO TO 18                                          CD 947
  14      IRL(I) = IRL(I) + 1                                             CD 948
          I1 = JRL(I)                                                     CD 949
          IF (IRL(I) .GE. IL(I+1)) GO TO 17                               CD 950
          IJLB = IRL(I) - IL(I) + IJL(I)                                  CD 951
          J = JL(IJLB)                                                    CD 952
  15      IF (I .GT. JRL(J)) GO TO 16                                     CD 953
            J = JRL(J)                                                    CD 954
            GO TO 15                                                      CD 955
  16      JRL(I) = JRL(J)                                                 CD 956
          JRL(J) = I                                                      CD 957
  17      I = I1                                                          CD 958
          IF (I .NE. 0) GO TO 14                                          CD 959
  18      IF (IRL(K) .GE. IL(K+1)) GO TO 19                               CD 960
          J = JL(IJL(K))                                                  CD 961
          JRL(K) = JRL(J)                                                 CD 962
          JRL(J) = K                                                      CD 963
  19      CONTINUE                                                        CD 964
C                                                                         CD 965
C  ******  SOLVE  UX = TMP  BY BACK SUBSTITUTION  **********************  CD 966
        K = N                                                             CD 967
        DO 22 I=1,N                                                       CD 968
          SUM =  TMP(K)                                                   CD 969
          JMIN = IU(K)                                                    CD 970
          JMAX = IU(K+1) - 1                                              CD 971
          IF (JMIN .GT. JMAX)  GO TO 21                                   CD 972
          MU = IJU(K) - JMIN                                              CD 973
          DO 20 J=JMIN,JMAX                                               CD 974
  20        SUM = SUM - U(J) * TMP(JU(MU+J))                              CD 975
  21      TMP(K) =  SUM                                                   CD 976
          Z(C(K)) =  SUM                                                  CD 977
  22      K = K-1                                                         CD 978
        FLAG = 0                                                          CD 979
        RETURN                                                            CD 980
C                                                                         CD 981
C ** ERROR:  INSUFFICIENT STORAGE FOR L                                   CD 982
 104    FLAG = 4*N + 1                                                    CD 983
        RETURN                                                            CD 984
C ** ERROR:  INSUFFICIENT STORAGE FOR U                                   CD 985
 107    FLAG = 7*N + 1                                                    CD 986
        RETURN                                                            CD 987
C ** ERROR:  ZERO PIVOT                                                   CD 988
 108    FLAG = 8*N + K                                                    CD 989
        RETURN                                                            CD 990
        END                                                               CD 991

        SUBROUTINE  TRK
     *     (N, R,IC, IA,JA,A, Z, B, IJU,JU,IU,U,MAX,                      TD 304
     *      Q, IM, ROW, TMP, FLAG, ESP, LRATIO)                           TD 305
C                                                                         TD 306
C       INPUT VARIABLES:   N, R,IC, IA,JA,A, B, MAX, LRATIO               TD 307
C       OUTPUT VARIABLES:  Z, FLAG, ESP                                   TD 308
C                                                                         TD 309
C       PARAMETERS USED INTERNALLY:                                       TD 310
C NIA   \ Q     - SUPPOSE M' IS THE RESULT OF REORDERING M;  IF           TD 311
C       \           PROCESSING OF THE KTH ROW OF M' (HENCE THE KTH ROWS   TD 312
C       \           OF L AND U) IS BEING DONE, THEN Q(J) IS INITIALLY     TD 313
C       \           NONZERO IF M'(K,J) IS NONZERO;  SINCE VALUES NEED     TD 314
C       \           NOT BE STORED, EACH ENTRY POINTS TO THE NEXT          TD 315
C       \           NONZERO;  FOR EXAMPLE, IF  N=9  AND THE 5TH ROW OF    TD 316
C       \           M' IS                                                 TD 317
C       \                   0 X X 0 X 0 0 X 0,                            TD 318
C       \           THEN Q WILL INITIALLY BE                              TD 319
C       \                   A 3 5 A 8 A A 10 A 2        (A - ARBITRARY);  TD 320
C       \           Q(N+1) POINTS TO THE FIRST NONZERO IN THE ROW AND     TD 321
C       \           THE LAST NONZERO POINTS TO  N+1;  AS THE ALGORITHM    TD 322
C       \           PROCEEDS, OTHER ELEMENTS OF Q ARE INSERTED IN THE     TD 323
C       \           LIST BECAUSE OF FILLIN.                               TD 324
C       \           SIZE = N+1.                                           TD 325
C NIA   \ IM  - AT EACH STEP IN THE FACTORIZATION, IM(I) IS THE LAST      TD 326
C       \         ELEMENT OF THE ITH ROW OF U WHICH NEEDS TO BE           TD 327
C       \         CONSIDERED IN COMPUTING FILLIN.                         TD 328
C       \         SIZE = N.                                               TD 329
C FIA   \ ROW - HOLDS INTERMEDIATE VALUES IN CALCULATION OF U.            TD 330
C       \         SIZE = N.                                               TD 331
C FIA   \ TMP - HOLDS NEW RIGHT-HAND SIDE B' FOR SOLUTION OF THE          TD 332
C       \         EQUATION  UX = B'.                                      TD 333
C       \         SIZE = N.                                               TD 334
C                                                                         TD 335
        INTEGER  R(1), IC(1),  IA(1), JA(1),  IJU(1), JU(1), IU(1),       TD 336
     *     Q(1),  IM(1),  FLAG,  ESP,  VJ, QM                             TD 337
C       REAL  A(1), Z(1), B(1),  U(1),  ROW(1), TMP(1), SUM, AKI, DK      TD 338
        DOUBLE PRECISION  A(1),Z(1),B(1),U(1),ROW(1),TMP(1),SUM,AKI,DK    TD 339
C                                                                         TD 340
C  ******  INITIALIZE  *************************************************  TD 341
        JUMIN = 1                                                         TD 342
        JUMAX = 0                                                         TD 343
        IU(1) = MAX                                                       TD 344
C                                                                         TD 345
C  ******  FOR EACH ROW  ***********************************************  TD 346
        DO 20 K=1,N                                                       TD 347
C  ******  INITIALIZE Q AND ROW TO THE KTH ROW OF REORDERED A  *********  TD 348
          LUK = 0                                                         TD 349
          Q(N+1) = N+1                                                    TD 350
          JMIN = IA(R(K))                                                 TD 351
          JMAX = IA(R(K)+1) - 1                                           TD 352
          IF (JMIN.GT.JMAX)  GO TO 101                                    TD 353
          DO 2 J=JMIN,JMAX                                                TD 354
            VJ = IC(JA(J))                                                TD 355
            QM = N+1                                                      TD 356
   1        M = QM                                                        TD 357
            QM = Q(M)                                                     TD 358
            IF (QM.LT.VJ)  GO TO 1                                        TD 359
            IF (QM.EQ.VJ)  GO TO 102                                      TD 360
              LUK = LUK+1                                                 TD 361
              Q(M) = VJ                                                   TD 362
              Q(VJ) = QM                                                  TD 363
              ROW(VJ) = A(J)                                              TD 364
   2        CONTINUE                                                      TD 365
C                                                                         TD 366
C  ******  LINK THROUGH Q  *********************************************  TD 367
          LMAX = 0                                                        TD 368
          IJU(K) = JUMAX                                                  TD 369
          I = N+1                                                         TD 370
   3      I = Q(I)                                                        TD 371
          LUK = LUK-1                                                     TD 372
          IF (I.GE.K)  GO TO 8                                            TD 373
            QM = I                                                        TD 374
            LUI = 0                                                       TD 375
            JMIN = IJU(I)                                                 TD 376
            JMAX = IM(I)                                                  TD 377
            IF (JMIN.GT.JMAX)  GO TO 7                                    TD 378
C  ******  AND FIND NONZERO STRUCTURE OF KTH ROW OF L AND U  ***********  TD 379
              DO 5 J=JMIN,JMAX                                            TD 380
                VJ = JU(J)                                                TD 381
                IF (VJ.GT.K)  LUI = LUI+1                                 TD 382
   4            M = QM                                                    TD 383
                QM = Q(M)                                                 TD 384
                IF (QM.LT.VJ)  GO TO 4                                    TD 385
                IF (QM.EQ.VJ)  GO TO 5                                    TD 386
                  LUK = LUK+1                                             TD 387
                  Q(M) = VJ                                               TD 388
                  Q(VJ) = QM                                              TD 389
                  ROW(VJ) = 0                                             TD 390
                  QM = VJ                                                 TD 391
   5            CONTINUE                                                  TD 392
C  ******  ADJUST IJU AND IM  ******************************************  TD 393
              JTMP = JMAX - LUI                                           TD 394
              IF (LUI.LE.LMAX)  GO TO 6                                   TD 395
                LMAX = LUI                                                TD 396
                IJU(K) = JTMP+1                                           TD 397
   6          IF (JTMP.LT.JMIN)  GO TO 7                                  TD 398
                IF (JU(JTMP).EQ.K)  IM(I) = JTMP                          TD 399
   7        GO TO 3                                                       TD 400
C                                                                         TD 401
C  ******  SEE IF JU STORAGE CAN BE COMPRESSED  ************************  TD 402
   8      IF (I.NE.K)  GO TO 105                                          TD 403
          IF (LUK.EQ.LMAX)  GO TO 14                                      TD 404
            I = Q(K)                                                      TD 405
            IF (JUMIN.GT.JUMAX)  GO TO 12                                 TD 406
              DO 9 JMIN=JUMIN,JUMAX                                       TD 407
                IF (JU(JMIN)-I)  9, 10, 12                                TD 408
   9            CONTINUE                                                  TD 409
              GO TO 12                                                    TD 410
  10          IJU(K) = JMIN                                               TD 411
              DO 11 J=JMIN,JUMAX                                          TD 412
                IF (JU(J).NE.I)  GO TO 12                                 TD 413
                I = Q(I)                                                  TD 414
                IF (I.GT.N)  GO TO 14                                     TD 415
  11            CONTINUE                                                  TD 416
              JUMAX = JMIN - 1                                            TD 417
C  ******  STORE POINTERS IN JU  ***************************************  TD 418
  12        I = K                                                         TD 419
            JUMIN = JUMAX +  1                                            TD 420
            JUMAX = JUMAX + LUK                                           TD 421
            IF (JUMAX.GT.LRATIO*(IU(K)-1)+1)  GO TO 112                   TD 422
            DO 13 J=JUMIN,JUMAX                                           TD 423
              I = Q(I)                                                    TD 424
  13          JU(J) = I                                                   TD 425
            IJU(K) = JUMIN                                                TD 426
  14      IU(K+1) = IU(K) - LUK                                           TD 427
          IF (JUMAX.GT.LRATIO*(IU(K+1)-1)+1)  GO TO 112                   TD 428
          IM(K) = IJU(K) + LUK - 1                                        TD 429
C                                                                         TD 430
C  ******  CALCULATE NUMERICAL VALUES FOR KTH ROW  *********************  TD 431
          SUM = B(R(K))                                                   TD 432
          I = N+1                                                         TD 433
  15      I = Q(I)                                                        TD 434
          IF (I.GE.K)  GO TO 18                                           TD 435
            AKI = - ROW(I)                                                TD 436
            SUM = SUM + AKI * TMP(I)                                      TD 437
            JMIN = IU(I+1) + 1                                            TD 438
            JMAX = IU(I)                                                  TD 439
            IF (JMIN.GT.JMAX)  GO TO 17                                   TD 440
            MU = IJU(I) - JMIN                                            TD 441
            DO 16 J=JMIN,JMAX                                             TD 442
  16          ROW(JU(MU+J)) = ROW(JU(MU+J)) + AKI * U(J)                  TD 443
  17        GO TO 15                                                      TD 444
C  ******  STORE VALUES IN TMP AND U  **********************************  TD 445
  18      IF (ROW(K).EQ.0)  GO TO 108                                     TD 446
          DK = 1 / ROW(K)                                                 TD 447
          TMP(K) = SUM * DK                                               TD 448
          JMIN = IU(K+1) + 1                                              TD 449
          JMAX = IU(K)                                                    TD 450
          IF (JMIN.GT.JMAX)  GO TO 20                                     TD 451
          MU = IJU(K) - JMIN                                              TD 452
          DO 19 J=JMIN,JMAX                                               TD 453
  19        U(J) = ROW(JU(MU+J)) * DK                                     TD 454
  20      CONTINUE                                                        TD 455
C                                                                         TD 456
C  ******  SOLVE  UX = TMP  BY BACK SUBSTITUTION  **********************  TD 457
        K = N                                                             TD 458
        DO 23 I=1,N                                                       TD 459
          SUM = TMP(K)                                                    TD 460
          JMIN = IU(K+1) + 1                                              TD 461
          JMAX = IU(K)                                                    TD 462
          IF (JMIN.GT.JMAX)  GO TO 22                                     TD 463
          MU = IJU(K) - JMIN                                              TD 464
          DO 21 J=JMIN,JMAX                                               TD 465
  21        SUM = SUM - U(J) * TMP(JU(MU+J))                              TD 466
  22      TMP(K) = SUM                                                    TD 467
  23      K = K-1                                                         TD 468
        DO 24 K=1,N                                                       TD 469
  24      Z(K) = TMP(IC(K))                                               TD 470
C                                                                         TD 471
        FLAG = 0                                                          TD 472
        ESP = IU(N+1) - 1 - (JUMAX - 1)/LRATIO                            TD 473
        RETURN                                                            TD 474
C                                                                         TD 475
C ** ERROR:  NULL ROW IN A                                                TD 476
 101    FLAG = N + R(K)                                                   TD 477
        RETURN                                                            TD 478
C ** ERROR:  DUPLICATE ENTRY IN A                                         TD 479
 102    FLAG = 2*N + R(K)                                                 TD 480
        RETURN                                                            TD 481
C ** ERROR:  NULL PIVOT                                                   TD 482
 105    FLAG = 5*N + K                                                    TD 483
        RETURN                                                            TD 484
C ** ERROR:  ZERO PIVOT                                                   TD 485
 108    FLAG = 8*N + K                                                    TD 486
        RETURN                                                            TD 487
C ** ERROR:  INSUFFICIENT STORAGE FOR JU AND U                            TD 488
 112    FLAG = 12*N + K                                                   TD 489
        RETURN                                                            TD 490
        END                                                               TD 491

        SUBROUTINE  NDRV
     *     (N, R,C,IC, IA,JA,A, B, Z, NSP,ISP,RSP,ESP, PATH, FLAG)        ND  12
C                                                                         ND  13
C    PARAMETERS                                                           ND  14
C    CLASS ABBREVIATIONS ARE --                                           ND  15
C       N - INTEGER VARIABLE                                              ND  16
C       F - REAL VARIABLE                                                 ND  17
C       V - SUPPLIES A VALUE TO THE DRIVER                                ND  18
C       R - RETURNS A RESULT FROM THE DRIVER                              ND  19
C       I - USED INTERNALLY BY THE DRIVER                                 ND  20
C       A - ARRAY                                                         ND  21
C                                                                         ND  22
C CLASS \ PARAMETER                                                       ND  23
C ------+----------                                                       ND  24
C       \                                                                 ND  25
C         THE NONZERO ENTRIES OF THE COEFFICIENT MATRIX M ARE STORED      ND  26
C    ROW-BY-ROW IN THE ARRAY A.  TO IDENTIFY THE INDIVIDUAL NONZERO       ND  27
C    ENTRIES IN EACH ROW, WE NEED TO KNOW IN WHICH COLUMN EACH ENTRY      ND  28
C    LIES.  THE COLUMN INDICES WHICH CORRESPOND TO THE NONZERO ENTRIES    ND  29
C    OF M ARE STORED IN THE ARRAY JA;  I.E., IF  A(K) = M(I,J),  THEN     ND  30
C    JA(K) = J.  IN ADDITION, WE NEED TO KNOW WHERE EACH ROW STARTS AND   ND  31
C    HOW LONG IT IS.  THE INDEX POSITIONS IN JA AND A WHERE THE ROWS OF   ND  32
C    M BEGIN ARE STORED IN THE ARRAY IA;  I.E., IF M(I,J) IS THE FIRST    ND  33
C    NONZERO ENTRY (STORED) IN THE I-TH ROW AND A(K) = M(I,J),  THEN      ND  34
C    IA(I) = K.  MOREOVER, THE INDEX IN JA AND A OF THE FIRST LOCATION    ND  35
C    FOLLOWING THE LAST ELEMENT IN THE LAST ROW IS STORED IN IA(N+1).     ND  36
C    THUS, THE NUMBER OF ENTRIES IN THE I-TH ROW IS GIVEN BY              ND  37
C    IA(I+1) - IA(I),  THE NONZERO ENTRIES OF THE I-TH ROW ARE STORED     ND  38
C    CONSECUTIVELY IN                                                     ND  39
C            A(IA(I)),  A(IA(I)+1),  ..., A(IA(I+1)-1),                   ND  40
C    AND THE CORRESPONDING COLUMN INDICES ARE STORED CONSECUTIVELY IN     ND  41
C            JA(IA(I)), JA(IA(I)+1), ..., JA(IA(I+1)-1).                  ND  42
C    FOR EXAMPLE, THE 5 BY 5 MATRIX                                       ND  43
C                ( 1. 0. 2. 0. 0.)                                        ND  44
C                ( 0. 3. 0. 0. 0.)                                        ND  45
C            M = ( 0. 4. 5. 6. 0.)                                        ND  46
C                ( 0. 0. 0. 7. 0.)                                        ND  47
C                ( 0. 0. 0. 8. 9.)                                        ND  48
C    WOULD BE STORED AS                                                   ND  49
C               \ 1  2  3  4  5  6  7  8  9                               ND  50
C            ---+--------------------------                               ND  51
C            IA \ 1  3  4  7  8 10                                        ND  52
C            JA \ 1  3  2  2  3  4  4  4  5                               ND  53
C             A \ 1. 2. 3. 4. 5. 6. 7. 8. 9.         .                    ND  54
C                                                                         ND  55
C NV    \ N     - NUMBER OF VARIABLES/EQUATIONS.                          ND  56
C FVA   \ A     - NONZERO ENTRIES OF THE COEFFICIENT MATRIX M, STORED     ND  57
C       \           BY ROWS.                                              ND  58
C       \           SIZE = NUMBER OF NONZERO ENTRIES IN M.                ND  59
C NVA   \ IA    - POINTERS TO DELIMIT THE ROWS IN A.                      ND  60
C       \           SIZE = N+1.                                           ND  61
C NVA   \ JA    - COLUMN NUMBERS CORRESPONDING TO THE ELEMENTS OF A.      ND  62
C       \           SIZE = SIZE OF A.                                     ND  63
C FVA   \ B     - RIGHT-HAND SIDE B;  B AND Z CAN THE SAME ARRAY.         ND  64
C       \           SIZE = N.                                             ND  65
C FRA   \ Z     - SOLUTION X;  B AND Z CAN BE THE SAME ARRAY.             ND  66
C       \           SIZE = N.                                             ND  67
C                                                                         ND  68
C         THE ROWS AND COLUMNS OF THE ORIGINAL MATRIX M CAN BE            ND  69
C    REORDERED (E.G., TO REDUCE FILLIN OR ENSURE NUMERICAL STABILITY)     ND  70
C    BEFORE CALLING THE DRIVER.  IF NO REORDERING IS DONE, THEN SET       ND  71
C    R(I) = C(I) = IC(I) = I  FOR I=1,...,N.  THE SOLUTION Z IS RETURNED  ND  72
C    IN THE ORIGINAL ORDER.                                               ND  73
C                                                                         ND  74
C NVA   \ R     - ORDERING OF THE ROWS OF M.                              ND  75
C       \           SIZE = N.                                             ND  76
C NVA   \ C     - ORDERING OF THE COLUMNS OF M.                           ND  77
C       \           SIZE = N.                                             ND  78
C NVA   \ IC    - INVERSE OF THE ORDERING OF THE COLUMNS OF M;  I.E.,     ND  79
C       \           IC(C(I)) = I  FOR I=1,...,N.                          ND  80
C       \           SIZE = N.                                             ND  81
C                                                                         ND  82
C         THE SOLUTION OF THE SYSTEM OF LINEAR EQUATIONS IS DIVIDED INTO  ND  83
C    THREE STAGES --                                                      ND  84
C      NSF -- THE MATRIX M IS PROCESSED SYMBOLICALLY TO DETERMINE WHERE   ND  85
C              FILLIN WILL OCCUR DURING THE NUMERIC FACTORIZATION.        ND  86
C      NNF -- THE MATRIX M IS FACTORED NUMERICALLY INTO THE PRODUCT LDU   ND  87
C              OF A UNIT LOWER TRIANGULAR MATRIX L, A DIAGONAL MATRIX D,  ND  88
C              AND A UNIT UPPER TRIANGULAR MATRIX U, AND THE SYSTEM       ND  89
C              MX = B  IS SOLVED.                                         ND  90
C      NNS -- THE LINEAR SYSTEM  MX = B  IS SOLVED USING THE LDU          ND  91
C  OR          FACTORIZATION FROM NNF.                                    ND  92
C      NNT -- THE TRANSPOSED LINEAR SYSTEM  MT X = B  IS SOLVED USING     ND  93
C              THE LDU FACTORIZATION FROM NNF.                            ND  94
C    FOR SEVERAL SYSTEMS WHOSE COEFFICIENT MATRICES HAVE THE SAME         ND  95
C    NONZERO STRUCTURE, NSF NEED BE DONE ONLY ONCE (FOR THE FIRST         ND  96
C    SYSTEM);  THEN NNF IS DONE ONCE FOR EACH ADDITIONAL SYSTEM.  FOR     ND  97
C    SEVERAL SYSTEMS WITH THE SAME COEFFICIENT MATRIX, NSF AND NNF NEED   ND  98
C    BE DONE ONLY ONCE (FOR THE FIRST SYSTEM);  THEN NNS OR NNT IS DONE   ND  99
C    ONCE FOR EACH ADDITIONAL RIGHT-HAND SIDE.                            ND 100
C                                                                         ND 101
C NV    \ PATH  - PATH SPECIFICATION;  VALUES AND THEIR MEANINGS ARE --   ND 102
C       \           1  PERFORM NSF AND NNF.                               ND 103
C       \           2  PERFORM NNF ONLY  (NSF IS ASSUMED TO HAVE BEEN     ND 104
C       \               DONE IN A MANNER COMPATIBLE WITH THE STORAGE      ND 105
C       \               ALLOCATION USED IN THE DRIVER).                   ND 106
C       \           3  PERFORM NNS ONLY  (NSF AND NNF ARE ASSUMED TO      ND 107
C       \               HAVE BEEN DONE IN A MANNER COMPATIBLE WITH THE    ND 108
C       \               STORAGE ALLOCATION USED IN THE DRIVER).           ND 109
C       \           4  PERFORM NNT ONLY  (NSF AND NNF ARE ASSUMED TO      ND 110
C       \               HAVE BEEN DONE IN A MANNER COMPATIBLE WITH THE    ND 111
C       \               STORAGE ALLOCATION USED IN THE DRIVER).           ND 112
C       \           5  PERFORM NSF ONLY.                                  ND 113
C                                                                         ND 114
C         VARIOUS ERRORS ARE DETECTED BY THE DRIVER AND THE INDIVIDUAL    ND 115
C    SUBROUTINES.                                                         ND 116
C                                                                         ND 117
C NR    \ FLAG  - ERROR FLAG;  VALUES AND THEIR MEANINGS ARE --           ND 118
C       \             0     NO ERRORS DETECTED                            ND 119
C       \             N+K   NULL ROW IN A  --  ROW = K                    ND 120
C       \            2N+K   DUPLICATE ENTRY IN A  --  ROW = K             ND 121
C       \            3N+K   INSUFFICIENT STORAGE IN NSF  --  ROW = K      ND 122
C       \            4N+1   INSUFFICIENT STORAGE IN NNF                   ND 123
C       \            5N+K   NULL PIVOT  --  ROW = K                       ND 124
C       \            6N+K   INSUFFICIENT STORAGE IN NSF  --  ROW = K      ND 125
C       \            7N+1   INSUFFICIENT STORAGE IN NNF                   ND 126
C       \            8N+K   ZERO PIVOT  --  ROW = K                       ND 127
C       \           10N+1   INSUFFICIENT STORAGE IN NDRV                  ND 128
C       \           11N+1   ILLEGAL PATH SPECIFICATION                    ND 129
C                                                                         ND 130
C         WORKING STORAGE IS NEEDED FOR THE FACTORED FORM OF THE MATRIX   ND 131
C    M PLUS VARIOUS TEMPORARY VECTORS.  THE ARRAYS ISP AND RSP SHOULD BE  ND 132
C    EQUIVALENCED;  INTEGER STORAGE IS ALLOCATED FROM THE BEGINNING OF    ND 133
C    ISP AND REAL STORAGE FROM THE END OF RSP.                            ND 134
C                                                                         ND 135
C NV    \ NSP   - DECLARED DIMENSION OF RSP;  NSP GENERALLY MUST          ND 136
C       \           BE LARGER THAN  5N+3 + 2K  (WHERE  K = (NUMBER OF     ND 137
C       \           NONZERO ENTRIES IN M)).                               ND 138
C NVIRA \ ISP   - INTEGER WORKING STORAGE DIVIDED UP INTO VARIOUS ARRAYS  ND 139
C       \           NEEDED BY THE SUBROUTINES;  ISP AND RSP SHOULD BE     ND 140
C       \           EQUIVALENCED.                                         ND 141
C       \           SIZE = LRATIO*NSP                                     ND 142
C FVIRA \ RSP   - REAL WORKING STORAGE DIVIDED UP INTO VARIOUS ARRAYS     ND 143
C       \           NEEDED BY THE SUBROUTINES;  ISP AND RSP SHOULD BE     ND 144
C       \           EQUIVALENCED.                                         ND 145
C       \           SIZE = NSP.                                           ND 146
C NR    \ ESP   - IF SUFFICIENT STORAGE WAS AVAILABLE TO PERFORM THE      ND 147
C       \           SYMBOLIC FACTORIZATION (NSF), THEN ESP IS SET TO THE  ND 148
C       \           AMOUNT OF EXCESS STORAGE PROVIDED (NEGATIVE IF        ND 149
C       \           INSUFFICIENT STORAGE WAS AVAILABLE TO PERFORM THE     ND 150
C       \           NUMERIC FACTORIZATION (NNF)).                         ND 151
C                                                                         ND 152
C                                                                         ND 153
C  CONVERSION TO DOUBLE PRECISION                                         ND 154
C                                                                         ND 155
C    TO CONVERT THESE ROUTINES FOR DOUBLE PRECISION ARRAYS, SIMPLY USE    ND 156
C    THE DOUBLE PRECISION DECLARATIONS IN PLACE OF THE REAL DECLARATIONS  ND 157
C    IN EACH SUBPROGRAM;  IN ADDITION, THE DATA VALUE OF THE INTEGER      ND 158
C    VARIABLE LRATIO MUST BE SET AS INDICATED IN SUBROUTINE NDRV          ND 159
C                                                                         ND 160
        INTEGER  R(1), C(1), IC(1),  IA(1), JA(1),  ISP(1), ESP,          ND 161
     *     PATH, FLAG,  Q, IM, D, U, ROW, TMP,  UMAX                      ND 162
C       REAL  A(1),  B(1),  Z(1),  RSP(1)                                 ND 163
        DOUBLE PRECISION  A(1),  B(1),  Z(1),  RSP(1)                     ND 164
C                                                                         ND 165
C  SET LRATIO EQUAL TO THE RATIO BETWEEN THE LENGTH OF FLOATING POINT     ND 166
C  AND INTEGER ARRAY DATA;  E. G., LRATIO = 1 FOR (REAL, INTEGER),        ND 167
C  LRATIO = 2 FOR (DOUBLE PRECISION, INTEGER)                             ND 168
C                                                                         ND 169
        DATA LRATIO/2/                                                    ND 170
C                                                                         ND 171
        IF (PATH.LT.1 .OR. 5.LT.PATH)  GO TO 111                          ND 172
C  ******  INITIALIZE AND DIVIDE UP TEMPORARY STORAGE  *****************  ND 173
        IL = 1                                                            ND 174
        IU = IL + N+1                                                     ND 175
        JL = IU + N+1                                                     ND 176
C                                                                         ND 177
C  ******  CALL NSF IF FLAG IS SET  ************************************  ND 178
        IF ((PATH-1) * (PATH-5) .NE. 0)  GO TO 2                          ND 179
          MAX = (LRATIO*NSP + 1 - JL) - (N+1) - N                         ND 180
          JLMAX = MAX/2                                                   ND 181
          Q     = JL  + JLMAX                                             ND 182
          IM    = Q   + (N+1)                                             ND 183
          JUTMP = IM  +   N                                               ND 184
          JUMAX = LRATIO*NSP + 1 - JUTMP                                  ND 185
          ESP = MAX/LRATIO                                                ND 186
          IF (JLMAX.LE.0 .OR. JUMAX.LE.0)  GO TO 110                      ND 187
          CALL  NSF                                                       ND 188
     *       (N,  R, IC,  IA, JA,                                         ND 189
     *        ISP(IL), ISP(JL), JLMAX,  ISP(IU), ISP(JUTMP), JUMAX,       ND 190
     *        ISP(Q),  ISP(IM),  FLAG)                                    ND 191
          IF (FLAG.NE.0)  GO TO 100                                       ND 192
C  ******  MOVE JU NEXT TO JL  *****************************************  ND 193
          JLMAX = ISP(IL+N)-1                                             ND 194
          JU    = JL + JLMAX                                              ND 195
          JUMAX = ISP(IU+N)-1                                             ND 196
          IF (JUMAX.LE.0)  GO TO 2                                        ND 197
          DO 1 J=1,JUMAX                                                  ND 198
   1        ISP(JU+J-1) = ISP(JUTMP+J-1)                                  ND 199
C                                                                         ND 200
C  ******  CALL REMAINING SUBROUTINES  *********************************  ND 201
   2    JLMAX = ISP(IL+N)-1                                               ND 202
        JU    = JL  + JLMAX                                               ND 203
        JUMAX = ISP(IU+N)-1                                               ND 204
        L     = (JU + JUMAX - 2 + LRATIO)  /  LRATIO    +    1            ND 205
        LMAX  = JLMAX                                                     ND 206
        D     = L   + LMAX                                                ND 207
        U     = D   + N                                                   ND 208
        ROW   = NSP + 1 - N                                               ND 209
        TMP   = ROW - N                                                   ND 210
        UMAX  = TMP - U                                                   ND 211
        ESP = UMAX - JUMAX                                                ND 212
C                                                                         ND 213
        IF ((PATH-1) * (PATH-2) .NE. 0)  GO TO 3                          ND 214
          IF (UMAX.LE.0)  GO TO 110                                       ND 215
          CALL  NNF                                                       ND 216
     *       (N,  R, C, IC,  IA, JA, A,  Z,  B,                           ND 217
     *        ISP(IL), ISP(JL), RSP(L), LMAX,   RSP(D),                   ND 218
     *           ISP(IU), ISP(JU), RSP(U), UMAX,                          ND 219
     *        RSP(ROW),  RSP(TMP),  FLAG)                                 ND 220
          IF (FLAG.NE.0)  GO TO 100                                       ND 221
          RETURN                                                          ND 222
C                                                                         ND 223
   3    IF ((PATH-3) .NE. 0)  GO TO 4                                     ND 224
          CALL  NNS                                                       ND 225
     *       (N,  R, C,                                                   ND 226
     *        ISP(IL), ISP(JL), RSP(L),  RSP(D),                          ND 227
     *          ISP(IU), ISP(JU), RSP(U),                                 ND 228
     *        Z,  B,  RSP(TMP))                                           ND 229
C                                                                         ND 230
   4    IF ((PATH-4) .NE. 0)  GO TO 5                                     ND 231
          CALL  NNT                                                       ND 232
     *       (N,  R, C,                                                   ND 233
     *        ISP(IL), ISP(JL), RSP(L),  RSP(D),                          ND 234
     *          ISP(IU), ISP(JU), RSP(U),                                 ND 235
     *        Z,  B,  RSP(TMP))                                           ND 236
   5    RETURN                                                            ND 237
C                                                                         ND 238
C ** ERROR:  ERROR DETECTED IN NSF, NNF, NNS, OR NNT                      ND 239
 100    RETURN                                                            ND 240
C ** ERROR:  INSUFFICIENT STORAGE                                         ND 241
 110    FLAG = 10*N + 1                                                   ND 242
        RETURN                                                            ND 243
C ** ERROR:  ILLEGAL PATH SPECIFICATION                                   ND 244
 111    FLAG = 11*N + 1                                                   ND 245
        RETURN                                                            ND 246
        END                                                               ND 247

        SUBROUTINE  SRO
     *     (N, IP, IA,JA,A, Q, R, DFLAG)                                  OD 603
C                                                                         OD 604
C  DESCRIPTION                                                            OD 605
C                                                                         OD 606
C    THE NONZERO ENTRIES OF THE MATRIX M ARE ASSUMED TO BE STORED         OD 607
C    SYMMETRICALLY IN (IA,JA,A) FORMAT (I.E., NOT BOTH M(I,J) AND M(J,I)  OD 608
C    ARE STORED IF I NE J).                                               OD 609
C                                                                         OD 610
C    SRO DOES NOT REARRANGE THE ORDER OF THE ROWS, BUT DOES MOVE          OD 611
C    NONZEROES FROM ONE ROW TO ANOTHER TO ENSURE THAT IF M(I,J) WILL BE   OD 612
C    IN THE UPPER TRIANGLE OF M WITH RESPECT TO THE NEW ORDERING, THEN    OD 613
C    M(I,J) IS STORED IN ROW I (AND THUS M(J,I) IS NOT STORED);  WHEREAS  OD 614
C    IF M(I,J) WILL BE IN THE STRICT LOWER TRIANGLE OF M, THEN M(J,I) IS  OD 615
C    STORED IN ROW J (AND THUS M(I,J) IS NOT STORED).                     OD 616
C                                                                         OD 617
C                                                                         OD 618
C  ADDITIONAL PARAMETERS                                                  OD 619
C                                                                         OD 620
C    Q     - INTEGER ONE-DIMENSIONAL WORK ARRAY;  DIMENSION = N           OD 621
C                                                                         OD 622
C    R     - INTEGER ONE-DIMENSIONAL WORK ARRAY;  DIMENSION = NUMBER OF   OD 623
C            NONZERO ENTRIES IN THE UPPER TRIANGLE OF M                   OD 624
C                                                                         OD 625
C    DFLAG - LOGICAL VARIABLE;  IF DFLAG = .TRUE., THEN STORE NONZERO     OD 626
C            DIAGONAL ELEMENTS AT THE BEGINNING OF THE ROW                OD 627
C                                                                         OD 628
C-----------------------------------------------------------------------  OD 629
C                                                                         OD 630
        INTEGER  IP(1),  IA(1), JA(1),  Q(1), R(1)                        OD 631
C       REAL  A(1),  AK                                                   OD 632
        DOUBLE PRECISION  A(1),  AK                                       OD 633
        LOGICAL  DFLAG                                                    OD 634
C                                                                         OD 635
C                                                                         OD 636
C--PHASE 1 -- FIND ROW IN WHICH TO STORE EACH NONZERO                     OD 637
C----INITIALIZE COUNT OF NONZEROES TO BE STORED IN EACH ROW               OD 638
        DO 1 I=1,N                                                        OD 639
  1       Q(I) = 0                                                        OD 640
C                                                                         OD 641
C----FOR EACH NONZERO ELEMENT A(J)                                        OD 642
        DO 3 I=1,N                                                        OD 643
          JMIN = IA(I)                                                    OD 644
          JMAX = IA(I+1) - 1                                              OD 645
          IF (JMIN.GT.JMAX)  GO TO 3                                      OD 646
          DO 2 J=JMIN,JMAX                                                OD 647
C                                                                         OD 648
C--------FIND ROW (=R(J)) AND COLUMN (=JA(J)) IN WHICH TO STORE A(J) ...  OD 649
            K = JA(J)                                                     OD 650
            IF (IP(K).LT.IP(I))  JA(J) = I                                OD 651
            IF (IP(K).GE.IP(I))  K = I                                    OD 652
            R(J) = K                                                      OD 653
C                                                                         OD 654
C--------... AND INCREMENT COUNT OF NONZEROES (=Q(R(J)) IN THAT ROW       OD 655
  2         Q(K) = Q(K) + 1                                               OD 656
  3       CONTINUE                                                        OD 657
C                                                                         OD 658
C                                                                         OD 659
C--PHASE 2 -- FIND NEW IA AND PERMUTATION TO APPLY TO (JA,A)              OD 660
C----DETERMINE POINTERS TO DELIMIT ROWS IN PERMUTED (JA,A)                OD 661
        DO 4 I=1,N                                                        OD 662
          IA(I+1) = IA(I) + Q(I)                                          OD 663
  4       Q(I) = IA(I+1)                                                  OD 664
C                                                                         OD 665
C----DETERMINE WHERE EACH (JA(J),A(J)) IS STORED IN PERMUTED (JA,A)       OD 666
C----FOR EACH NONZERO ELEMENT (IN REVERSE ORDER)                          OD 667
        ILAST = 0                                                         OD 668
        JMIN = IA(1)                                                      OD 669
        JMAX = IA(N+1) - 1                                                OD 670
        J = JMAX                                                          OD 671
        DO 6 JDUMMY=JMIN,JMAX                                             OD 672
          I = R(J)                                                        OD 673
          IF (.NOT.DFLAG .OR. JA(J).NE.I .OR. I.EQ.ILAST)  GO TO 5        OD 674
C                                                                         OD 675
C------IF DFLAG, THEN PUT DIAGONAL NONZERO AT BEGINNING OF ROW            OD 676
            R(J) = IA(I)                                                  OD 677
            ILAST = I                                                     OD 678
            GO TO 6                                                       OD 679
C                                                                         OD 680
C------PUT (OFF-DIAGONAL) NONZERO IN LAST UNUSED LOCATION IN ROW          OD 681
  5         Q(I) = Q(I) - 1                                               OD 682
            R(J) = Q(I)                                                   OD 683
C                                                                         OD 684
  6       J = J-1                                                         OD 685
C                                                                         OD 686
C                                                                         OD 687
C--PHASE 3 -- PERMUTE (JA,A) TO UPPER TRIANGULAR FORM (WRT NEW ORDERING)  OD 688
        DO 8 J=JMIN,JMAX                                                  OD 689
  7       IF (R(J).EQ.J)  GO TO 8                                         OD 690
            K = R(J)                                                      OD 691
            R(J) = R(K)                                                   OD 692
            R(K) = K                                                      OD 693
            JAK = JA(K)                                                   OD 694
            JA(K) = JA(J)                                                 OD 695
            JA(J) = JAK                                                   OD 696
            AK = A(K)                                                     OD 697
            A(K) = A(J)                                                   OD 698
            A(J) = AK                                                     OD 699
            GO TO 7                                                       OD 700
  8       CONTINUE                                                        OD 701
C                                                                         OD 702
        RETURN                                                            OD 703
        END                                                               OD 704

        SUBROUTINE  NNS
     *     (N, R,C, IL,JL,L, D, IU,JU,U, Z, B, TMP)                       ND 633
C                                                                         ND 634
C       INPUT VARIABLES:   N, R,C, IL,JL,L, D, IU,JU,U, B                 ND 635
C       OUTPUT VARIABLES:  Z                                              ND 636
C                                                                         ND 637
C       PARAMETERS USED INTERNALLY:                                       ND 638
C FIA   \ TMP   - HOLDS NEW RIGHT-HAND SIDE B' FOR SOLUTION OF THE        ND 639
C       \           EQUATION UX = B'.                                     ND 640
C       \           SIZE = N.                                             ND 641
C                                                                         ND 642
        INTEGER  R(1), C(1),  IL(1), JL(1),  IU(1), JU(1)                 ND 643
C       REAL  L(1), D(1), U(1),  Z(1), B(1),  TMP(1), SUM                 ND 644
        DOUBLE PRECISION  L(1), D(1), U(1),  Z(1), B(1),  TMP(1), SUM     ND 645
C                                                                         ND 646
C  ******  SOLVE LDY = B  BY FORWARD SUBSTITUTION  *********************  ND 647
        DO 2 K=1,N                                                        ND 648
          SUM = B(R(K))                                                   ND 649
          JMIN = IL(K)                                                    ND 650
          JMAX = IL(K+1) - 1                                              ND 651
          IF (JMIN.GT.JMAX)  GO TO 2                                      ND 652
          DO 1 J=JMIN,JMAX                                                ND 653
   1        SUM = SUM - L(J) * TMP(JL(J))                                 ND 654
   2      TMP(K) = SUM * D(K)                                             ND 655
C                                                                         ND 656
C  ******  SOLVE  UX = Y  BY BACK SUBSTITUTION  ************************  ND 657
        K = N                                                             ND 658
        DO 5 I=1,N                                                        ND 659
          SUM = TMP(K)                                                    ND 660
          JMIN = IU(K)                                                    ND 661
          JMAX = IU(K+1) - 1                                              ND 662
          IF (JMIN.GT.JMAX)  GO TO 4                                      ND 663
          DO 3 J=JMIN,JMAX                                                ND 664
   3        SUM = SUM - U(J) * TMP(JU(J))                                 ND 665
   4      TMP(K) = SUM                                                    ND 666
          Z(C(K)) = SUM                                                   ND 667
   5      K = K-1                                                         ND 668
        RETURN                                                            ND 669
        END                                                               ND 670

        SUBROUTINE SDRV
     *     (N, P,IP, IA,JA,A, B, Z, NSP,ISP,RSP,ESP, PATH, FLAG)          SD   6
C                                                                         SD   7
C  DESCRIPTION                                                            SD   8
C                                                                         SD   9
C    SDRV SOLVES SPARSE SYMMETRIC POSITIVE DEFINITE SYSTEMS OF LINEAR     SD  10
C    EQUATIONS.  THE SOLUTION PROCESS IS DIVIDED INTO THREE STAGES --     SD  11
C                                                                         SD  12
C      SSF - THE COEFFICIENT MATRIX M IS FACTORED SYMBOLICALLY TO         SD  13
C            DETERMINE WHERE FILLIN WILL OCCUR DURING THE NUMERIC         SD  14
C            FACTORIZATION.                                               SD  15
C                                                                         SD  16
C      SNF - M IS FACTORED NUMERICALLY INTO THE PRODUCT UT-D-U, WHERE     SD  17
C            D IS DIAGONAL AND U IS UNIT UPPER TRIANGULAR.                SD  18
C                                                                         SD  19
C      SNS - THE LINEAR SYSTEM  MX = B  IS SOLVED USING THE UT-D-U        SD  20
C            FACTORIZATION FROM SNF.                                      SD  21
C                                                                         SD  22
C    FOR SEVERAL SYSTEMS WITH THE SAME COEFFICIENT MATRIX, SSF AND SNF    SD  23
C    NEED BE DONE ONLY ONCE (FOR THE FIRST SYSTEM);  THEN SNS IS DONE     SD  24
C    ONCE FOR EACH ADDITIONAL RIGHT-HAND SIDE.  FOR SEVERAL SYSTEMS       SD  25
C    WHOSE COEFFICIENT MATRICES HAVE THE SAME NONZERO STRUCTURE, SSF      SD  26
C    NEED BE DONE ONLY ONCE (FOR THE FIRST SYSTEM);  THEN SNF AND SNS     SD  27
C    ARE DONE ONCE FOR EACH ADDITIONAL SYSTEM.                            SD  28
C                                                                         SD  29
C                                                                         SD  30
C  STORAGE OF SPARSE MATRICES                                             SD  31
C                                                                         SD  32
C    THE NONZERO ENTRIES OF THE MATRIX M ARE STORED ROW-BY-ROW IN THE     SD  33
C    ARRAY A.  TO IDENTIFY THE INDIVIDUAL NONZERO ENTRIES IN EACH ROW,    SD  34
C    WE NEED TO KNOW IN WHICH COLUMN EACH ENTRY LIES.  THESE COLUMN       SD  35
C    INDICES ARE STORED IN THE ARRAY JA;  I.E., IF  A(K) = M(I,J),  THEN  SD  36
C    JA(K) = J.  TO IDENTIFY THE INDIVIDUAL ROWS, WE NEED TO KNOW WHERE   SD  37
C    EACH ROW STARTS.  THESE ROW POINTERS ARE STORED IN THE ARRAY IA;     SD  38
C    I.E., IF M(I,J) IS THE FIRST NONZERO ENTRY (STORED) IN THE I-TH ROW  SD  39
C    AND  A(K) = M(I,J),  THEN  IA(I) = K.  MOREOVER, IA(N+1) POINTS TO   SD  40
C    THE FIRST LOCATION FOLLOWING THE LAST ELEMENT IN THE LAST ROW.       SD  41
C    THUS, THE NUMBER OF ENTRIES IN THE I-TH ROW IS  IA(I+1) - IA(I),     SD  42
C    THE NONZERO ENTRIES IN THE I-TH ROW ARE STORED CONSECUTIVELY IN      SD  43
C                                                                         SD  44
C            A(IA(I)),  A(IA(I)+1),  ..., A(IA(I+1)-1),                   SD  45
C                                                                         SD  46
C    AND THE CORRESPONDING COLUMN INDICES ARE STORED CONSECUTIVELY IN     SD  47
C                                                                         SD  48
C            JA(IA(I)), JA(IA(I)+1), ..., JA(IA(I+1)-1).                  SD  49
C                                                                         SD  50
C    SINCE THE COEFFICIENT MATRIX IS SYMMETRIC, ONLY THE NONZERO ENTRIES  SD  51
C    IN THE UPPER TRIANGLE NEED BE STORED, FOR EXAMPLE, THE MATRIX        SD  52
C                                                                         SD  53
C             ( 1  0  2  3  0 )                                           SD  54
C             ( 0  4  0  0  0 )                                           SD  55
C         M = ( 2  0  5  6  0 )                                           SD  56
C             ( 3  0  6  7  8 )                                           SD  57
C             ( 0  0  0  8  9 )                                           SD  58
C                                                                         SD  59
C    COULD BE STORED AS                                                   SD  60
C                                                                         SD  61
C            \ 1  2  3  4  5  6  7  8  9 10 11 12 13                      SD  62
C         ---+--------------------------------------                      SD  63
C         IA \ 1  4  5  8 12 14                                           SD  64
C         JA \ 1  3  4  2  1  3  4  1  3  4  5  4  5                      SD  65
C          A \ 1  2  3  4  2  5  6  3  6  7  8  8  9                      SD  66
C                                                                         SD  67
C    OR (SYMMETRICALLY) AS                                                SD  68
C                                                                         SD  69
C            \ 1  2  3  4  5  6  7  8  9                                  SD  70
C         ---+--------------------------                                  SD  71
C         IA \ 1  4  5  7  9 10                                           SD  72
C         JA \ 1  3  4  2  3  4  4  5  5                                  SD  73
C          A \ 1  2  3  4  5  6  7  8  9          .                       SD  74
C                                                                         SD  75
C                                                                         SD  76
C  REORDERING THE ROWS AND COLUMNS OF M                                   SD  77
C                                                                         SD  78
C    A SYMMETRIC PERMUTATION OF THE ROWS AND COLUMNS OF THE COEFFICIENT   SD  79
C    MATRIX M (E.G., WHICH REDUCES FILLIN OR ENHANCES NUMERICAL           SD  80
C    STABILITY) MUST BE SPECIFIED.  THE SOLUTION Z IS RETURNED IN THE     SD  81
C    ORIGINAL ORDER.                                                      SD  82
C                                                                         SD  83
C    TO SPECIFY THE TRIVIAL ORDERING (I.E., THE IDENTITY PERMUTATION),    SD  84
C    SET  P(I) = IP(I) = I,  I=1,...,N.  IN THIS CASE, P AND IP CAN BE    SD  85
C    THE SAME ARRAY.                                                      SD  86
C                                                                         SD  87
C    IF A NONTRIVIAL ORDERING (I.E., NOT THE IDENTITY PERMUTATION) IS     SD  88
C    SPECIFIED AND M IS STORED SYMMETRICALLY (I.E., NOT BOTH M(I,J) AND   SD  89
C    M(J,I) ARE STORED FOR I NE J), THEN ODRV SHOULD BE CALLED (WITH      SD  90
C    PATH = 3 OR 5) TO SYMMETRICALLY REORDER (IA,JA,A) BEFORE CALLING     SD  91
C    SDRV.  THIS IS TO ENSURE THAT IF M(I,J) WILL BE IN THE UPPER         SD  92
C    TRIANGLE OF M WITH RESPECT TO THE NEW ORDERING, THEN M(I,J) IS       SD  93
C    STORED IN ROW I (AND THUS M(J,I) IS NOT STORED);  WHEREAS IF M(I,J)  SD  94
C    WILL BE IN THE STRICT LOWER TRIANGLE OF M, THEN M(J,I) IS STORED IN  SD  95
C    ROW J (AND THUS M(I,J) IS NOT STORED).                               SD  96
C                                                                         SD  97
C                                                                         SD  98
C  PARAMETERS                                                             SD  99
C                                                                         SD 100
C    N    - NUMBER OF VARIABLES/EQUATIONS                                 SD 101
C                                                                         SD 102
C    P    - INTEGER ONE-DIMENSIONAL ARRAY SPECIFYING A PERMUTATION OF     SD 103
C           THE ROWS AND COLUMNS OF M;  DIMENSION = N                     SD 104
C                                                                         SD 105
C    IP   - INTEGER ONE-DIMENSIONAL ARRAY CONTAINING THE INVERSE OF THE   SD 106
C           PERMUTATION SPECIFIED IN P;  I.E., IP(P(I)) = I, I=1,...,N;   SD 107
C           DIMENSION = N                                                 SD 108
C                                                                         SD 109
C    IA   - INTEGER ONE-DIMENSIONAL ARRAY CONTAINING POINTERS TO DELIMIT  SD 110
C           ROWS IN JA AND A;  DIMENSION = N+1                            SD 111
C                                                                         SD 112
C    JA   - INTEGER ONE-DIMENSIONAL ARRAY CONTAINING THE COLUMN INDICES   SD 113
C           CORRESPONDING TO THE ELEMENTS OF A;  DIMENSION = NUMBER OF    SD 114
C           NONZERO ENTRIES IN M STORED                                   SD 115
C                                                                         SD 116
C    A    - REAL ONE-DIMENSIONAL ARRAY CONTAINING THE NONZERO ENTRIES IN  SD 117
C           THE COEFFICIENT MATRIX M, STORED BY ROWS;  DIMENSION =        SD 118
C           NUMBER OF NONZERO ENTRIES IN M STORED                         SD 119
C                                                                         SD 120
C    B    - REAL ONE-DIMENSIONAL ARRAY CONTAINING THE RIGHT-HAND SIDE B;  SD 121
C           B AND Z CAN BE THE SAME ARRAY;  DIMENSION = N                 SD 122
C                                                                         SD 123
C    Z    - REAL ONE-DIMENSIONAL ARRAY CONTAINING THE SOLUTION X;  Z AND  SD 124
C           B CAN BE THE SAME ARRAY;  DIMENSION = N                       SD 125
C                                                                         SD 126
C    NSP  - DECLARED DIMENSION OF THE ONE-DIMENSIONAL ARRAYS ISP AND      SD 127
C           RSP;  NSP MUST BE (SUBSTANTIALLY) LARGER THAN  3N+2K,  WHERE  SD 128
C           K = NUMBER OF NONZERO ENTRIES IN THE UPPER TRIANGLE OF M      SD 129
C                                                                         SD 130
C    ISP  - INTEGER ONE-DIMENSIONAL ARRAY USED FOR WORKING STORAGE;  ISP  SD 131
C           AND RSP SHOULD BE EQUIVALENCED;  DIMENSION = NSP              SD 132
C                                                                         SD 133
C    RSP  - REAL ONE-DIMENSIONAL ARRAY USED FOR WORKING STORAGE;  RSP     SD 134
C           AND ISP SHOULD BE EQUIVALENCED;  DIMENSION = NSP              SD 135
C                                                                         SD 136
C    ESP  - INTEGER VARIABLE;  IF SUFFICIENT STORAGE WAS AVAILABLE TO     SD 137
C           PERFORM THE SYMBOLIC FACTORIZATION (SSF), THEN ESP IS SET TO  SD 138
C           THE AMOUNT OF EXCESS STORAGE PROVIDED (NEGATIVE IF            SD 139
C           INSUFFICIENT STORAGE WAS AVAILABLE TO PERFORM THE NUMERIC     SD 140
C           FACTORIZATION (SNF))                                          SD 141
C                                                                         SD 142
C    PATH - INTEGER PATH SPECIFICATION;  VALUES AND THEIR MEANINGS ARE -  SD 143
C             1  PERFORM SSF, SNF, AND SNS                                SD 144
C             2  PERFORM SNF AND SNS (ISP/RSP IS ASSUMED TO HAVE BEEN     SD 145
C                  SET UP IN AN EARLIER CALL TO SDRV (FOR SSF))           SD 146
C             3  PERFORM SNS ONLY (ISP/RSP IS ASSUMED TO HAVE BEEN SET    SD 147
C                  UP IN AN EARLIER CALL TO SDRV (FOR SSF AND SNF))       SD 148
C             4  PERFORM SSF                                              SD 149
C             5  PERFORM SSF AND SNF                                      SD 150
C             6  PERFORM SNF ONLY (ISP/RSP IS ASSUMED TO HAVE BEEN SET    SD 151
C                  UP IN AN EARLIER CALL TO SDRV (FOR SSF))               SD 152
C                                                                         SD 153
C    FLAG - INTEGER ERROR FLAG;  VALUES AND THEIR MEANINGS ARE -          SD 154
C               0     NO ERRORS DETECTED                                  SD 155
C              2N+K   DUPLICATE ENTRY IN A  --  ROW = K                   SD 156
C              6N+K   INSUFFICIENT STORAGE IN SSF  --  ROW = K            SD 157
C              7N+1   INSUFFICIENT STORAGE IN SNF                         SD 158
C              8N+K   ZERO PIVOT  --  ROW = K                             SD 159
C             10N+1   INSUFFICIENT STORAGE IN SDRV                        SD 160
C             11N+1   ILLEGAL PATH SPECIFICATION                          SD 161
C                                                                         SD 162
C                                                                         SD 163
C  CONVERSION FROM REAL TO DOUBLE PRECISION                               SD 164
C                                                                         SD 165
C    CHANGE THE REAL DECLARATIONS IN SDRV, SNF, AND SNS TO DOUBLE         SD 166
C    PRECISION DECLARATIONS;  AND CHANGE THE VALUE IN THE DATA STATEMENT  SD 167
C    FOR THE INTEGER VARIABLE RATIO (IN SDRV) FROM 1 TO 2.                SD 168
C                                                                         SD 169
C-----------------------------------------------------------------------  SD 170
C                                                                         SD 171
        INTEGER  P(1), IP(1),  IA(1), JA(1),  ISP(1), ESP,  PATH,  FLAG,  SD 172
     *     RATIO,  Q, MARK, D, U, TMP,  UMAX                              SD 173
C       REAL  A(1),  B(1),  Z(1),  RSP(1)                                 SD 174
C       DATA  RATIO/1/                                                    SD 175
        DOUBLE PRECISION  A(1),  B(1),  Z(1),  RSP(1)                     SD 176
        DATA  RATIO/2/                                                    SD 177
C                                                                         SD 178
C----VALIDATE PATH SPECIFICATION                                          SD 179
        IF (PATH.LT.1 .OR. 6.LT.PATH)  GO TO 111                          SD 180
C                                                                         SD 181
C----ALLOCATE STORAGE AND FACTOR M SYMBOLICALLY TO DETERMINE FILL-IN      SD 182
        IJU   = 1                                                         SD 183
        IU    = IJU     +  N                                              SD 184
        JL    = IU      + N+1                                             SD 185
        JU    = JL      +  N                                              SD 186
        Q     = (NSP+1) -  N                                              SD 187
        MARK  = Q       -  N                                              SD 188
        JUMAX = MARK    - JU                                              SD 189
C                                                                         SD 190
        IF ((PATH-1) * (PATH-4) * (PATH-5) .NE. 0)  GO TO 1               SD 191
          IF (JUMAX.LE.0)  GO TO 110                                      SD 192
          CALL SSF                                                        SD 193
     *       (N,  P, IP,  IA, JA,  ISP(IJU), ISP(JU), ISP(IU), JUMAX,     SD 194
     *        ISP(Q), ISP(MARK), ISP(JL), FLAG)                           SD 195
          IF (FLAG.NE.0)  GO TO 100                                       SD 196
C                                                                         SD 197
C----ALLOCATE STORAGE AND FACTOR M NUMERICALLY                            SD 198
   1    IL   = JU      + ISP(IJU+(N-1))                                   SD 199
        TMP  = ((IL-1)+(RATIO-1)) / RATIO  +  1                           SD 200
        D    = TMP     + N                                                SD 201
        U    = D       + N                                                SD 202
        UMAX = (NSP+1) - U                                                SD 203
        ESP  = UMAX    - (ISP(IU+N)-1)                                    SD 204
C                                                                         SD 205
        IF ((PATH-1) * (PATH-2) * (PATH-5) * (PATH-6) .NE. 0)  GO TO 2    SD 206
          IF (UMAX.LE.0)  GO TO 110                                       SD 207
          CALL SNF                                                        SD 208
     *       (N,  P, IP,  IA, JA, A,                                      SD 209
     *        RSP(D),  ISP(IJU), ISP(JU), ISP(IU), RSP(U), UMAX,          SD 210
     *        ISP(IL),  ISP(JL),  FLAG)                                   SD 211
          IF (FLAG.NE.0)  GO TO 100                                       SD 212
C                                                                         SD 213
C----SOLVE SYSTEM OF LINEAR EQUATIONS  MX = B                             SD 214
   2    IF ((PATH-1) * (PATH-2) * (PATH-3) .NE. 0)  GO TO 3               SD 215
          IF (UMAX.LE.0)  GO TO 110                                       SD 216
          CALL SNS                                                        SD 217
     *       (N,  P,  RSP(D), ISP(IJU), ISP(JU), ISP(IU), RSP(U),  Z, B,  SD 218
     *        RSP(TMP))                                                   SD 219
C                                                                         SD 220
   3    RETURN                                                            SD 221
C                                                                         SD 222
C ** ERROR -- ERROR DETECTED IN SSF, SNF, OR SNS                          SD 223
 100    RETURN                                                            SD 224
C ** ERROR -- INSUFFICIENT STORAGE                                        SD 225
 110    FLAG = 10*N + 1                                                   SD 226
        RETURN                                                            SD 227
C ** ERROR -- ILLEGAL PATH SPECIFICATION                                  SD 228
 111    FLAG = 11*N + 1                                                   SD 229
        RETURN                                                            SD 230
        END                                                               SD 231

        SUBROUTINE  NSF
     *     (N, R,IC, IA,JA, IL,JL,JLMAX, IU,JU,JUMAX, Q, IM, FLAG)        ND 398
C                                                                         ND 399
C       INPUT VARIABLES:   N, R,IC, IA,JA, JLMAX, JUMAX.                  ND 400
C       OUTPUT VARIABLES:  IL,JL, IU,JU, FLAG.                            ND 401
C                                                                         ND 402
C       PARAMETERS USED INTERNALLY:                                       ND 403
C NIA   \ Q     - SUPPOSE M' IS THE RESULT OF REORDERING M;  IF           ND 404
C       \           PROCESSING OF THE KTH ROW OF M' (HENCE THE KTH ROWS   ND 405
C       \           OF L AND U) IS BEING DONE, THEN Q(J) IS INITIALLY     ND 406
C       \           NONZERO IF M'(K,J) IS NONZERO;  SINCE VALUES NEED     ND 407
C       \           NOT BE STORED, EACH ENTRY POINTS TO THE NEXT          ND 408
C       \           NONZERO;  FOR EXAMPLE, IF  N=9  AND THE 5TH ROW OF    ND 409
C       \           M' IS                                                 ND 410
C       \                   0 X X 0 X 0 0 X 0,                            ND 411
C       \           THEN Q WILL INITIALLY BE                              ND 412
C       \                   A 3 5 A 8 A A 10 A 2        (A - ARBITRARY);  ND 413
C       \           Q(N+1) POINTS TO THE FIRST NONZERO IN THE ROW AND     ND 414
C       \           THE LAST NONZERO POINTS TO  N+1;  AS THE ALGORITHM    ND 415
C       \           PROCEEDS, OTHER ELEMENTS OF Q ARE INSERTED IN THE     ND 416
C       \           LIST BECAUSE OF FILLIN.                               ND 417
C       \           SIZE = N+1.                                           ND 418
C NIA   \ IM    - AT EACH STEP IN THE FACTORIZATION, IM(I) IS THE LAST    ND 419
C       \           ELEMENT IN THE ITH ROW OF U WHICH NEEDS TO BE         ND 420
C       \           CONSIDERED IN COMPUTING FILLIN.                       ND 421
C       \           SIZE = N.                                             ND 422
C                                                                         ND 423
C  INTERNAL VARIABLES--                                                   ND 424
C    JLPTR - POINTS TO THE LAST POSITION USED IN  JL.                     ND 425
C    JUPTR - POINTS TO THE LAST POSITION USED IN  JU.                     ND 426
C                                                                         ND 427
        INTEGER  R(1), IC(1),  IA(1), JA(1),  IL(1), JL(1),               ND 428
     *     IU(1), JU(1),  Q(1),  IM(1),  FLAG,  QM, VJ                    ND 429
C                                                                         ND 430
C  ******  INITIALIZE POINTERS  ****************************************  ND 431
        JLPTR = 0                                                         ND 432
        IL(1) = 1                                                         ND 433
        JUPTR = 0                                                         ND 434
        IU(1) = 1                                                         ND 435
C                                                                         ND 436
C  ******  FOR EACH ROW OF L AND U  ************************************  ND 437
        DO 10 K=1,N                                                       ND 438
C  ******  SET Q TO THE REORDERED ROW OF A  ****************************  ND 439
          Q(N+1) = N+1                                                    ND 440
          JMIN = IA(R(K))                                                 ND 441
          JMAX = IA(R(K)+1) - 1                                           ND 442
          IF (JMIN.GT.JMAX)  GO TO 101                                    ND 443
          DO 2 J=JMIN,JMAX                                                ND 444
            VJ = IC(JA(J))                                                ND 445
            QM = N+1                                                      ND 446
   1        M = QM                                                        ND 447
            QM = Q(M)                                                     ND 448
            IF (QM.LT.VJ)  GO TO 1                                        ND 449
            IF (QM.EQ.VJ)  GO TO 102                                      ND 450
              Q(M) = VJ                                                   ND 451
              Q(VJ) = QM                                                  ND 452
   2        CONTINUE                                                      ND 453
C                                                                         ND 454
C  ******  FOR EACH ENTRY IN THE LOWER TRIANGLE  ***********************  ND 455
          I = N+1                                                         ND 456
   3      I = Q(I)                                                        ND 457
          IF (I.GE.K)  GO TO 7                                            ND 458
C  ******  L(K,I) WILL BE NONZERO, SO ADD IT TO JL  ********************  ND 459
            JLPTR = JLPTR+1                                               ND 460
            IF (JLPTR.GT.JLMAX)  GO TO 103                                ND 461
            JL(JLPTR) = I                                                 ND 462
            QM = I                                                        ND 463
C  ******  INSPECT ITH ROW FOR FILLIN, ADJUST IM IF POSSIBLE  **********  ND 464
            JMIN = IU(I)                                                  ND 465
            JMAX = IM(I)                                                  ND 466
            IF (JMIN.GT.JMAX)  GO TO 6                                    ND 467
            DO 5 J=JMIN,JMAX                                              ND 468
              VJ = JU(J)                                                  ND 469
              IF (VJ.EQ.K)  IM(I) = J                                     ND 470
   4          M = QM                                                      ND 471
              QM = Q(M)                                                   ND 472
              IF (QM.LT.VJ)  GO TO 4                                      ND 473
              IF (QM.EQ.VJ)  GO TO 5                                      ND 474
                Q(M) = VJ                                                 ND 475
                Q(VJ) = QM                                                ND 476
                QM = VJ                                                   ND 477
   5          CONTINUE                                                    ND 478
   6        GO TO 3                                                       ND 479
C                                                                         ND 480
C  ******  CHECK FOR NULL PIVOT  ***************************************  ND 481
   7      IF (I.NE.K)  GO TO 105                                          ND 482
C  ******  REMAINING ELEMENTS OF Q DEFINE STRUCTURE OF U(K, )  *********  ND 483
   8      I = Q(I)                                                        ND 484
          IF (I.GT.N)  GO TO 9                                            ND 485
            JUPTR = JUPTR+1                                               ND 486
            IF (JUPTR.GT.JUMAX)  GO TO 106                                ND 487
            JU(JUPTR) = I                                                 ND 488
            GO TO 8                                                       ND 489
C  ******  GET READY FOR NEXT ROW  *************************************  ND 490
   9      IM(K) = JUPTR                                                   ND 491
          IL(K+1) = JLPTR+1                                               ND 492
  10      IU(K+1) = JUPTR+1                                               ND 493
C                                                                         ND 494
        FLAG = 0                                                          ND 495
        RETURN                                                            ND 496
C                                                                         ND 497
C ** ERROR:  NULL ROW IN A                                                ND 498
 101    FLAG = N + R(K)                                                   ND 499
        RETURN                                                            ND 500
C ** ERROR:  DUPLICATE ENTRY IN A                                         ND 501
 102    FLAG = 2*N + R(K)                                                 ND 502
        RETURN                                                            ND 503
C ** ERROR:  INSUFFICIENT STORAGE FOR JL                                  ND 504
 103    FLAG = 3*N + K                                                    ND 505
        RETURN                                                            ND 506
C ** ERROR:  NULL PIVOT                                                   ND 507
 105    FLAG = 5*N + K                                                    ND 508
        RETURN                                                            ND 509
C ** ERROR:  INSUFFICIENT STORAGE FOR JU                                  ND 510
 106    FLAG = 6*N + K                                                    ND 511
        RETURN                                                            ND 512
        END                                                               ND 513

        SUBROUTINE  SNF
     *     (N, P,IP, IA,JA,A, D, IJU,JU,IU,U,UMAX, IL, JL, FLAG)          SD 490
C                                                                         SD 491
C  ADDITIONAL PARAMETERS                                                  SD 492
C                                                                         SD 493
C    IL    - INTEGER ONE-DIMENSIONAL WORK ARRAY;  DIMENSION = N           SD 494
C                                                                         SD 495
C    JL    - INTEGER ONE-DIMENSIONAL WORK ARRAY;  DIMENSION = N           SD 496
C                                                                         SD 497
C                                                                         SD 498
C  DEFINITIONS OF INTERNAL PARAMETERS (DURING K-TH STAGE OF ELIMINATION)  SD 499
C                                                                         SD 500
C    (D(I),I=K,N) CONTAINS THE K-TH ROW OF U (EXPANDED)                   SD 501
C                                                                         SD 502
C    IL(I) POINTS TO THE FIRST NONZERO ELEMENT IN COLUMNS K,...,N OF      SD 503
C      ROW I OF U                                                         SD 504
C                                                                         SD 505
C    JL CONTAINS LISTS OF ROWS TO BE ADDED TO UNELIMINATED ROWS --        SD 506
C      I GE K => JL(I) IS THE FIRST ROW TO BE ADDED TO ROW I              SD 507
C      I LT K => JL(I) IS THE ROW FOLLOWING ROW I IN SOME LIST OF ROWS    SD 508
C      IN EITHER CASE, JL(I) = 0 INDICATES THE END OF A LIST              SD 509
C                                                                         SD 510
C-----------------------------------------------------------------------  SD 511
C                                                                         SD 512
        INTEGER  P(1), IP(1),  IA(1), JA(1),  IJU(1), JU(1), IU(1),       SD 513
     *     UMAX,  IL(1),  JL(1),  FLAG,  VJ                               SD 514
C       REAL  A(1),  D(1), U(1),  DK, UKIDI                               SD 515
        DOUBLE PRECISION  A(1),  D(1), U(1),  DK, UKIDI                   SD 516
C                                                                         SD 517
C----CHECK FOR SUFFICIENT STORAGE FOR U                                   SD 518
        IF (IU(N+1)-1 .GT. UMAX)  GO TO 107                               SD 519
C                                                                         SD 520
C----INITIALIZATION                                                       SD 521
        DO 1 K=1,N                                                        SD 522
          D(K) = 0                                                        SD 523
   1      JL(K) = 0                                                       SD 524
C                                                                         SD 525
C----FOR EACH ROW K                                                       SD 526
        DO 11 K=1,N                                                       SD 527
C                                                                         SD 528
C------INITIALIZE K-TH ROW WITH ELEMENTS NONZERO IN ROW P(K) OF M         SD 529
   3      JMIN = IA(P(K))                                                 SD 530
          JMAX = IA(P(K)+1) - 1                                           SD 531
          IF (JMIN.GT.JMAX) GO TO 5                                       SD 532
          DO 4 J=JMIN,JMAX                                                SD 533
            VJ = IP(JA(J))                                                SD 534
            IF (K.LE.VJ)  D(VJ) = A(J)                                    SD 535
   4        CONTINUE                                                      SD 536
C                                                                         SD 537
C------MODIFY K-TH ROW BY ADDING IN THOSE ROWS I WITH U(I,K) NE 0         SD 538
C------FOR EACH ROW I TO BE ADDED IN                                      SD 539
   5      DK = D(K)                                                       SD 540
          I = JL(K)                                                       SD 541
   6      IF (I.EQ.0)  GO TO 9                                            SD 542
            NEXTI = JL(I)                                                 SD 543
C                                                                         SD 544
C--------COMPUTE MULTIPLIER AND UPDATE DIAGONAL ELEMENT                   SD 545
            ILI = IL(I)                                                   SD 546
            UKIDI = - U(ILI) * D(I)                                       SD 547
            DK = DK + UKIDI * U(ILI)                                      SD 548
            U(ILI) = UKIDI                                                SD 549
C                                                                         SD 550
C--------ADD MULTIPLE OF ROW I TO K-TH ROW ...                            SD 551
            JMIN = ILI     + 1                                            SD 552
            JMAX = IU(I+1) - 1                                            SD 553
            IF (JMIN.GT.JMAX)  GO TO 8                                    SD 554
              MU = IJU(I) - IU(I)                                         SD 555
              DO 7 J=JMIN,JMAX                                            SD 556
   7            D(JU(MU+J)) = D(JU(MU+J)) + UKIDI * U(J)                  SD 557
C                                                                         SD 558
C--------... AND ADD I TO ROW LIST FOR NEXT NONZERO ENTRY                 SD 559
              IL(I) = JMIN                                                SD 560
              J = JU(MU+JMIN)                                             SD 561
              JL(I) = JL(J)                                               SD 562
              JL(J) = I                                                   SD 563
C                                                                         SD 564
   8        I = NEXTI                                                     SD 565
            GO TO 6                                                       SD 566
C                                                                         SD 567
C------CHECK FOR ZERO PIVOT AND SAVE DIAGONAL ELEMENT                     SD 568
   9      IF (DK.EQ.0)  GO TO 108                                         SD 569
          D(K) = 1 / DK                                                   SD 570
C                                                                         SD 571
C------SAVE NONZERO ENTRIES IN K-TH ROW OF U ...                          SD 572
          JMIN = IU(K)                                                    SD 573
          JMAX = IU(K+1) - 1                                              SD 574
          IF (JMIN.GT.JMAX)  GO TO 11                                     SD 575
            MU = IJU(K) - JMIN                                            SD 576
            DO 10 J=JMIN,JMAX                                             SD 577
              JUMUJ = JU(MU+J)                                            SD 578
              U(J) = D(JUMUJ)                                             SD 579
  10          D(JUMUJ) = 0                                                SD 580
C                                                                         SD 581
C------... AND ADD K TO ROW LIST FOR FIRST NONZERO ENTRY IN K-TH ROW      SD 582
            IL(K) = JMIN                                                  SD 583
            I = JU(MU+JMIN)                                               SD 584
            JL(K) = JL(I)                                                 SD 585
            JL(I) = K                                                     SD 586
  11      CONTINUE                                                        SD 587
C                                                                         SD 588
        FLAG = 0                                                          SD 589
        RETURN                                                            SD 590
C                                                                         SD 591
C ** ERROR -- INSUFFICIENT STORAGE FOR U                                  SD 592
 107    FLAG = 7*N + 1                                                    SD 593
        RETURN                                                            SD 594
C ** ERROR -- ZERO PIVOT                                                  SD 595
 108    FLAG = 8*N + K                                                    SD 596
        RETURN                                                            SD 597
        END                                                               SD 598

        SUBROUTINE  SNS
     *     (N, P, D, IJU,JU,IU,U, Z, B, TMP)                              SD 605
        INTEGER  P(1),  IJU(1), JU(1), IU(1)                              SD 606
C       REAL  D(1), U(1),  Z(1), B(1),  TMP(1),  TMPK, SUM                SD 607
        DOUBLE PRECISION  D(1), U(1),  Z(1), B(1),  TMP(1),  TMPK, SUM    SD 608
C                                                                         SD 609
C  ADDITIONAL PARAMETERS                                                  SD 610
C                                                                         SD 611
C    TMP   - REAL ONE-DIMENSIONAL WORK ARRAY;  DIMENSION = N              SD 612
C                                                                         SD 613
C-----------------------------------------------------------------------  SD 614
C                                                                         SD 615
C----SET TMP TO PERMUTED B                                                SD 616
        DO 1 K=1,N                                                        SD 617
   1      TMP(K) = B(P(K))                                                SD 618
C                                                                         SD 619
C----SOLVE  UT D Y = B  BY FORWARD SUBSTITUTION                           SD 620
        DO 3 K=1,N                                                        SD 621
          TMPK = TMP(K)                                                   SD 622
          JMIN = IU(K)                                                    SD 623
          JMAX = IU(K+1) - 1                                              SD 624
          IF (JMIN.GT.JMAX)  GO TO 3                                      SD 625
          MU = IJU(K) - JMIN                                              SD 626
          DO 2 J=JMIN,JMAX                                                SD 627
   2        TMP(JU(MU+J)) = TMP(JU(MU+J)) + U(J) * TMPK                   SD 628
   3      TMP(K) = TMPK * D(K)                                            SD 629
C                                                                         SD 630
C----SOLVE  U X = Y  BY BACK SUBSTITUTION                                 SD 631
        K = N                                                             SD 632
        DO 6 I=1,N                                                        SD 633
          SUM = TMP(K)                                                    SD 634
          JMIN = IU(K)                                                    SD 635
          JMAX = IU(K+1) - 1                                              SD 636
          IF (JMIN.GT.JMAX)  GO TO 5                                      SD 637
          MU = IJU(K) - JMIN                                              SD 638
          DO 4 J=JMIN,JMAX                                                SD 639
   4        SUM = SUM + U(J) * TMP(JU(MU+J))                              SD 640
   5      TMP(K) = SUM                                                    SD 641
          Z(P(K)) = SUM                                                   SD 642
   6      K = K-1                                                         SD 643
C                                                                         SD 644
        RETURN                                                            SD 645
        END                                                               SD 646
